var mysql = require('mysql').createConnection(config.db);
module.exports = function (Engine) {
    var self = this;

    function query(input, callback) {
        if (typeof input == 'string') input = {query: input};
        console.log(input.query, input.data);
        mysql.query(input.query, input.data || [], function (err, result) {
            //console.log(err,result);
            if (err)return callback(err);
            callback(null, result);
        });
    }

    self.test = function (test_query, callback) {
        query(test_query, callback);
    };
    self.add_user = function (input, cb) {
        query({
            query: "INSERT INTO " + config.db.tables_prefix + "users (login, pass, app_id) VALUES (?,?,?)",
            data: [input.login, input.password, input.app_id]
        }, cb);
    };
    self.get_user_by_login = function (login, callback) {
        query("SELECT * FROM " + config.db.tables_prefix + "users WHERE login='" + login + "'", function (err, res) {
            if (err) callback(err);
            else callback(err, res[0] || null);
        });
    };
    self.get_user_by_id = function (id, callback) {
        query("SELECT * FROM " + config.db.tables_prefix + "users WHERE id='" + id + "'", function (err, res) {
            if (err) {
                return callback(err);
            }
            callback(err, res[0] || null);
        });
    };
    self.get_my_numbers = function (id, callback) {
        query("SELECT number,password,number_sid,token FROM " + config.db.tables_prefix + "number WHERE user_id=" + id, function (err, res) {
            if (err)return callback(err);
            callback(err, res || []);
        });
    };
    self.get_all_numbers = function (id, callback) {
        query("SELECT n.number,u.app_id FROM " + config.db.tables_prefix + "number as n LEFT JOIN " + config.db.tables_prefix + "users as u ON (n.user_id=u.id)", function (err, res) {
            if (err)return callback(err);
            callback(err, res || []);
        });
    };
    self.get_all_users = function (id, callback) {
        query("SELECT * FROM " + config.db.tables_prefix + "users", function (err, res) {
            if (err)return callback(err);
            callback(err, res || []);
        });
    };
    self.save_number = function (input, callback) {
        query({
            query: "REPLACE INTO " + config.db.tables_prefix + "number (number, password, number_sid, user_id, token) VALUES (?, ?, ?, ?, ?)",
            data: [input.number, input.password, input.number_sid, input.user_id, input.token]
        }, function (err, res) {
            if (err)return callback(err);
            callback(null, 'ok');
        });
    };
    self.get_number = function (number, callback) {
        query("SELECT * FROM " + config.db.tables_prefix + "number WHERE number=" + number, function (err, res) {
            if (err)return callback(err);
            callback(err, res[0]);
        });
    };
    self.update_number = function (input, callback) {
        var q = "UPDATE " + config.db.tables_prefix + "number SET ";
        if (input.password) q += "password = '" + input.password + "' ";
        if (input.push_id) q += "push_id = '" + input.push_id + "' ";
        q += "WHERE number = " + input.number;

        query({
            query: q,
            data: {}
        }, function (err, res) {
            if (err)return callback(err);
            callback(null, 'ok');
        });
    };
    self.delete_number = function (input, callback) {
        query({
            query: "DELETE FROM " + config.db.tables_prefix + "number WHERE number=?",
            data: [input.number]
        }, function (err, res) {
            if (err)return callback(err);
            callback(null, 'ok');
        });
    };

    return self;
};
