/**
* @constructor Apifo
*/
function _Apifo(){
	console.log('Apifo v1.1.0');
    var APIFO_PATH=window.location.origin+'/apifojs';
	//Flashphoner
    {
		var Configuration = {
			urlWsServer:(location.protocol.indexOf('s')>-1)?'wss://webrtc2.mtt.ru:8443':'ws://webrtc2.mtt.ru:8080',
			urlFlashServer:'rtmfp://webrtc2.mtt.ru:1935',
			appKey:"defaultApp",
			// Set sip domain
			sipDomain:"sip-eu.apifonica.com",
			sipPort:5060,
			
			sipRegisterRequired:true,
			use_dtls:true,
			reoffers_enabled:false,
			videoWidth:320,
			videoHeight:240,
			audioReliable:true,
			videoReliable:true,
			flashBufferTime:0.2,
			check_validation_callee:true,
			use_enhanced_mic:true,
			ring_sound:null,
			busy_sound:null,
			register_sound:null,
			finish_sound:null,
			strip_codecs:"G722",
			
			remoteMediaElementId : null,
			localMediaElementId : null,
			elementIdForSWF : 'flashVideoDiv',
			pathToSWF : '/flash/MediaManager.swf',
			sipContactParams : null,
			forceResolution : false,

			stunServer : "",

			stripCodecs : [],

			forceMediaProvider : null,
			calleeLetterCase : null,
			msrpCallee : null,
			subscribeEvent : null,
			loadBalancerUrl : null,
			jsonpSuccess : false,
			ringSound : "sounds/CALL_OUT.mp3",
			busySound : "sounds/BUSY.mp3",
			registerSound : "sounds/REGISTER.mp3",
			finishSound : "sounds/HANGUP.mp3",
			messageSound : "sounds/MESSAGE.mp3",
			hangupLT : 0,
			answerLT : 0,
			callLT : 0,
			disableUnknownMsgFiltering : false,
			disableLocalRing : false,
			suppressRingOnActiveAudioStream : false,
			reoffersEnabled : false,
			
			imdnEnabled : false,
			msgContentType : "text/plain",
			pushLogEnabled : false
		}
		function createUUID() {
			var s = [];
			var hexDigits = "0123456789abcdef";
			for (var i = 0; i < 36; i++) {
				s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
			}
			s[14] = "4";
			s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);
			s[8] = s[13] = s[18] = s[23] = "-";
			var uuid = s.join("");
			return uuid.substring(0, 18);
		}
		var DataMap = function () {
			return {
				data : {},
				add: function (id, data) {
					this.data[id] = data;
				},
				update: function (id, data) {
					this.data[id] = data;
				},
				get: function (id) {
					return this.data[id];
				},
				remove: function (id) {
					var data = this.data[id];
					delete this.data[id];
					return data;
				},
				getSize: function () {
					var size = 0, key;
					for (key in this.data) {
						if (this.data.hasOwnProperty(key)) size++;
					}
					return size;
				},
				getData: function () {
					return this.data;
				},
				array: function () {
					var callArray = [];
					for (var o in this.data) {
						callArray.push(this.data[o]);
					}
					return callArray;
				}
			};
		};
		var MediaProvider={
			WebRTC : "WebRTC",
			Flash : "Flash"
		}
		, ConnectionStatus={
			Pending : "PENDING",
			Registered : "REGISTERED",
			Established : "ESTABLISHED",
			Disconnected : "DISCONNECTED",
			Failed : "FAILED"	
		}
		, WCSEvent={
			ErrorStatusEvent : "ERROR_STATUS_EVENT",
			ConnectionStatusEvent : "CONNECTION_STATUS_EVENT",
			RegistrationStatusEvent : "REGISTRATION_STATUS_EVENT",
			OnCallEvent : "ON_CALL_EVENT",
			CallStatusEvent : "CALL_STATUS_EVENT",
			OnMessageEvent : "ON_MESSAGE_EVENT",
			MessageStatusEvent : "MESSAGE_STATUS_EVENT",
			RecordingStatusEvent : "RECORDING_STATUS_EVENT",
			SubscriptionStatusEvent : "SUBSCRIPTION_STATUS_EVENT",
			StreamStatusEvent : "ON_STREAM_STATUS_EVENT",
			XcapStatusEvent : "XCAP_STATUS_EVENT",
			BugReportStatusEvent : "BUG_REPORT_STATUS_EVENT",
			OnDataEvent : "ON_DATA_EVENT",
			DataStatusEvent : "DATA_STATUS_EVENT",
			TransferStatusEvent : "TRANSFER_STATUS_EVENT",
			OnTransferEvent : "ON_TRANSFER_EVENT",
			OnBinaryEvent : "ON_BINARY_EVENT"
		}
		, CallStatus = {
			RING : "RING",
			RING_MEDIA : "RING_MEDIA",
			HOLD : "HOLD",
			ESTABLISHED : "ESTABLISHED",
			FINISH : "FINISH",
			BUSY : "BUSY",
			SESSION_PROGRESS : "SESSION_PROGRESS"
		}
		, MessageStatus = {
			SENT : "SENT",
			ACCEPTED : "ACCEPTED",
			FAILED : "FAILED",
			IMDN_NOTIFICATION_SENT : "IMDN_NOTIFICATION_SENT",
			IMDN_DELIVERED : "IMDN_DELIVERED",
			IMDN_FAILED : "IMDN_FAILED",
			IMDN_FORBIDDEN : "IMDN_FORBIDDEN",
			IMDN_ERROR : "IMDN_ERROR",
			RECEIVED : "RECEIVED"
		}
		, WebRtcMediaConnection = function (webRtcMediaManager, stunServer, useDTLS, remoteMediaElementId) {
			var me = this;
			me.webRtcMediaManager = webRtcMediaManager;
			me.peerConnection = null;
			me.peerConnectionState = 'new';
			me.remoteAudioVideoMediaStream = null;
			me.remoteMediaElement = document.getElementById(remoteMediaElementId);
			me.stunServer = stunServer;
			me.useDTLS = useDTLS;
			me.lastReceivedSdp = null;
			//stun server by default
			//commented to speedup WebRTC call establishment
			//me.stunServer = "stun.l.google.com:19302";
			
			this.init = function () {
				if(SDK.debug) console.log("WebRtcMediaConnection - init");
				this.hasVideo = false;
				this.peerConnection = null;
				this.peerConnectionState = 'new';
				this.remoteAudioVideoMediaStream = null;
			};
			this.close = function () {
				//Commented to prevent termination of rtcMediaManager after MSRP call
				if(SDK.debug)console.log("WebRtcMediaConnection - close()");
				if (this.peerConnectionState != 'finished') {
					this.peerConnectionState = 'finished';
					if (this.peerConnection) {
						if(SDK.debug)console.log("WebRtcMediaConnection - PeerConnection will be closed");
						this.peerConnection.close();
						this.remoteMediaElement.pause();
					}
				} else if(SDK.debug) console.log("peerConnection already closed, do nothing!");
			};
			this.createPeerConnection = function () {
				if(SDK.debug) console.log("WebRtcMediaConnection - createPeerConnection()");
				var application = this;
				if (application.stunServer !== undefined && application.stunServer.length > 0) {
					pc_config = {
						"iceServers": [
							{"url": "stun:" + application.stunServer}
						]
					};
				} else {
					pc_config = {"iceServers": []};
				}
				this.peerConnection = new RTCPeerConnection(pc_config, {
					"optional": [
						{"DtlsSrtpKeyAgreement": true}
					]
				});
				this.peerConnection.onaddstream = function (event) {
					application.onOnAddStreamCallback(event);
				};
				this.peerConnection.onremovestream = function (event) {
					application.onOnRemoveStreamCallback(event);
				};
			};
			this.onOnAddStreamCallback = function (event) {
				if(SDK.debug) console.log("WebRtcMediaConnection - onOnAddStreamCallback(): event=" , event, event.stream, this.remoteMediaElement);
				if (this.peerConnection != null) {
					this.remoteAudioVideoMediaStream = event.stream;
					attachMediaStream(this.remoteMediaElement, this.remoteAudioVideoMediaStream);
				}
				else {
					console.warn("SimpleWebRtcSipPhone:onOnAddStreamCallback(): this.peerConnection is null, bug in state machine!, bug in state machine!");
				}
			};
			this.onOnRemoveStreamCallback = function (event) {
				if(SDK.debug)console.log("WebRtcMediaConnection - onOnRemoveStreamCallback(): event=" + event);
				if (this.peerConnection != null) {
					this.remoteAudioVideoMediaStream = null;
					this.remoteMediaElement.pause();
				} else {
					if(SDK.debug)console.warn("this.peerConnection is null, bug in state machine!");
				}
			};
			this.waitGatheringIce = function () {
				if (me.peerConnection != null) {
					sendSdp = function () {
						if (me.peerConnection != null) {
							if(SDK.debug)console.log("WebRtcMediaConnection - waitGatheringIce() iceGatheringState=" + me.peerConnection.iceGatheringState);
							if (me.peerConnection.iceGatheringState == "complete") {
								if(SDK.debug) console.log("WebRtcMediaConnection - setLocalSDP: sdp=" + me.peerConnection.localDescription.sdp);
								if (me.peerConnectionState == 'preparing-offer') {
									me.peerConnectionState = 'offer-sent';
									me.createOfferCallback(me.peerConnection.localDescription.sdp);// + this.candidates);
								} else if (me.peerConnectionState == 'preparing-answer') {
									me.peerConnectionState = 'established';
									me.createAnswerCallback(me.peerConnection.localDescription.sdp);// + this.candidates);
								} else if (me.peerConnectionState == 'established') {
								} else if(SDK.debug) console.log("WebRtcMediaConnection - onIceCandidateCallback(): RTCPeerConnection bad state!");
								clearInterval(me.iceIntervalId);
							}
						} else clearInterval(me.iceIntervalId);
					};
					me.iceIntervalId = setInterval(sendSdp, 500);
				}
				else if(SDK.debug) console.warn("WebRtcMediaConnection - onIceCandidateCallback(): this.peerConnection is null, bug in state machine!");
			};
			this.createOffer = function (createOfferCallback, hasAudio, hasVideo, receiveVideo) {
				if(SDK.debug)console.log("WebRtcMediaConnection - createOffer()");
				try {
					if (me.getConnectionState() != "established") {
						if(SDK.debug)console.log("Connection state is not established. Initializing...");
						me.init();
					}
					var mandatory = {};
					if (me.peerConnection == null) {
						if(SDK.debug)console.log("peerConnection is null");
						me.createPeerConnection();
						if (hasAudio && hasVideo) {
							if (me.webRtcMediaManager.videoTrack) {
								me.webRtcMediaManager.localAudioVideoStream.addTrack(me.webRtcMediaManager.videoTrack);
								me.webRtcMediaManager.videoTrack = null;
							}
							me.peerConnection.addStream(me.webRtcMediaManager.localAudioVideoStream);
						} else if (hasAudio) {
							if (me.webRtcMediaManager.localAudioStream) {
								me.peerConnection.addStream(me.webRtcMediaManager.localAudioStream);
							} else {
								var localAudioVideoStream = me.webRtcMediaManager.localAudioVideoStream;
								if (localAudioVideoStream.getVideoTracks().length > 0) {
									me.webRtcMediaManager.videoTrack = localAudioVideoStream.getVideoTracks()[0];
									localAudioVideoStream.removeTrack(me.webRtcMediaManager.videoTrack);
								}
								me.peerConnection.addStream(me.webRtcMediaManager.localAudioVideoStream);
							}
						} else {
							if (receiveVideo == undefined) receiveVideo = true;
							mandatory = {optional: [], mandatory: {OfferToReceiveAudio: true, OfferToReceiveVideo: receiveVideo}}
						}
					}
					me.createOfferCallback = createOfferCallback;
					me.peerConnection.createOffer(function (offer) {
						me.onCreateOfferSuccessCallback(offer);
					}, function (error) {
						me.onCreateOfferErrorCallback(error);
					}, mandatory);
				} catch (exception) {
					console.error("WebRtcMediaConnection - createOffer error:" + error);
				}
			};
			this.createAnswer = function (createAnswerCallback, hasVideo) {
				if(SDK.debug) console.log("WebRtcMediaConnection - createAnswer() me.getConnectionState(): " + me.getConnectionState() + " me.hasVideo: " + me.hasVideo);
				if (me.getConnectionState() != "established") me.init();
				try {
					if (me.peerConnection == null) {
						me.createPeerConnection();
						if (hasVideo) {
							if (me.webRtcMediaManager.videoTrack) {
								me.webRtcMediaManager.localAudioVideoStream.addTrack(me.webRtcMediaManager.videoTrack);
								me.webRtcMediaManager.videoTrack = null;
							}
							me.peerConnection.addStream(me.webRtcMediaManager.localAudioVideoStream);
						} else {
							if (me.webRtcMediaManager.localAudioStream) {
								me.peerConnection.addStream(me.webRtcMediaManager.localAudioStream);
							} else {
								var localAudioVideoStream = me.webRtcMediaManager.localAudioVideoStream;
								if (localAudioVideoStream.getVideoTracks().length > 0) {
									me.webRtcMediaManager.videoTrack = localAudioVideoStream.getVideoTracks()[0];
									localAudioVideoStream.removeTrack(me.webRtcMediaManager.videoTrack);
								}
								me.peerConnection.addStream(me.webRtcMediaManager.localAudioVideoStream);
							}
						}
					}
					me.createAnswerCallback = createAnswerCallback;
					var sdpOffer = new RTCSessionDescription({
						type: 'offer',
						sdp: me.lastReceivedSdp
					});
					me.peerConnectionState = 'offer-received';
					me.peerConnection.setRemoteDescription(sdpOffer, function () {
						me.onSetRemoteDescriptionSuccessCallback();
					}, function (error) {
						me.onSetRemoteDescriptionErrorCallback(error);
					});
				}
				catch (exception) {
					console.error("WebRtcMediaConnection - createAnswer(): catched exception:" + exception);
				}
			};
			this.onCreateOfferSuccessCallback = function (offer) {
				if(SDK.debug) console.log("WebRtcMediaConnection - onCreateOfferSuccessCallback this.peerConnection: " + this.peerConnection + " this.peerConnectionState: " + this.peerConnectionState);
				if (this.peerConnection != null) {
					if (this.peerConnectionState == 'new' || this.peerConnectionState == 'established') {
						var application = this;
						this.peerConnectionState = 'preparing-offer';
						this.peerConnection.setLocalDescription(offer, function () {
							application.onSetLocalDescriptionSuccessCallback(offer.sdp);
						}, function (error) {
							application.onSetLocalDescriptionErrorCallback(error);
						});
					}
					else console.error("WebRtcMediaConnection - onCreateOfferSuccessCallback(): RTCPeerConnection bad state!");
				}
				else console.warn("SimpleWebRtcSipPhone:onCreateOfferSuccessCallback(): this.peerConnection is null, bug in state machine!");
			};
			this.onSetLocalDescriptionSuccessCallback = function (sdp) {
				if(SDK.debug) console.log("WebRtcMediaConnection - onSetLocalDescriptionSuccessCallback");
				if (webrtcDetectedBrowser == "firefox") {
					if(SDK.debug) console.log("WebRtcMediaConnection - onSetLocalDescriptionSuccessCallback: sdp=" + sdp);
					if (this.peerConnectionState == 'preparing-offer') {
						if(SDK.debug) console.log("Current PeerConnectionState is 'preparing-offer' sending offer...");
						this.peerConnectionState = 'offer-sent';
						this.createOfferCallback(sdp);
					}
					else if (this.peerConnectionState == 'preparing-answer') {
						if(SDK.debug) console.log("Current PeerConnectionState is 'preparing-answer' going to established...");
						this.peerConnectionState = 'established';
						this.createAnswerCallback(sdp);
					}
				} else this.waitGatheringIce();
			};
			this.getConnectionState = function () {
				return this.peerConnectionState;
			};
			this.setRemoteSDP = function (sdp, isInitiator) {
				if(SDK.debug)console.log("WebRtcMediaConnection - setRemoteSDP: isInitiator: " + isInitiator + " sdp=" + sdp);
				if (isInitiator) {
					var sdpAnswer = new RTCSessionDescription({
						type: 'answer',
						sdp: sdp
					});
					var application = this;
					this.peerConnectionState = 'answer-received';
					this.peerConnection.setRemoteDescription(sdpAnswer, function () {
						application.onSetRemoteDescriptionSuccessCallback();
					}, function (error) {
						application.onSetRemoteDescriptionErrorCallback(error);
					});
				} else this.lastReceivedSdp = sdp;
			};
			this.onSetRemoteDescriptionSuccessCallback = function () {
				if(SDK.debug) console.log("onSetRemoteDescriptionSuccessCallback");
				if (this.peerConnection != null) {
					if (this.peerConnectionState == 'answer-received') {
						if(SDK.debug) console.log("Current PeerConnectionState is 'answer-received' changing the PeerConnectionState to 'established'");
						this.peerConnectionState = 'established';
					}
					else if (this.peerConnectionState == 'offer-received') {
						if(SDK.debug) console.log("Current PeerConnectionState is 'offer-received' creating appropriate answer...");
						var application = this;
						this.peerConnection.createAnswer(function (answer) {
							application.onCreateAnswerSuccessCallback(answer);
						}, function (error) {
							application.onCreateAnswerErrorCallback(error);
						});
					}
					else if(SDK.debug) console.log("WebRtcMediaConnection - onSetRemoteDescriptionSuccessCallback(): RTCPeerConnection bad state!");
				}
				else if(SDK.debug) console.warn("SimpleWebRtcSipPhone:onSetRemoteDescriptionSuccessCallback(): this.peerConnection is null, bug in state machine!");
			};
			this.onCreateAnswerSuccessCallback = function (answer) {
				if(SDK.debug) console.log("onCreateAnswerSuccessCallback " + this.peerConnection);
				if (this.peerConnection != null) {
					if (this.peerConnectionState == 'offer-received') {
						if(SDK.debug) console.log("Current PeerConnectionState is 'offer-received', preparing answer...");
						// Prepare answer.
						var application = this;
						this.peerConnectionState = 'preparing-answer';
						this.peerConnection.setLocalDescription(answer, function () {
							application.onSetLocalDescriptionSuccessCallback(answer.sdp);
						}, function (error) {
							application.onSetLocalDescriptionErrorCallback(error);
						});
					} else if(SDK.debug) console.log("WebRtcMediaConnection - onCreateAnswerSuccessCallback(): RTCPeerConnection bad state!");
				} else {
					if(SDK.debug) console.warn("SimpleWebRtcSipPhone:onCreateAnswerSuccessCallback(): this.peerConnection is null, bug in state machine!");
				}
			};
			this.getStatistics = function (callbackFn) {
				if (this.peerConnection && this.peerConnection.getRemoteStreams()[0] && webrtcDetectedBrowser == "chrome") {
					if (this.peerConnection.getStats) {
						this.peerConnection.getStats(function (rawStats) {
							var results = rawStats.result();
							var result = {type:"chrome", outgoingStreams: {}, incomingStreams: {}};
							for (var i = 0; i < results.length; ++i) {
								var resultPart = me.processGoogRtcStatsReport(results[i]);
								if (resultPart != null) {
									if (resultPart.type == "googCandidatePair") {
										result.activeCandidate = resultPart;
									} else if (resultPart.type == "ssrc") {
										if (resultPart.transportId.indexOf("audio") > -1) {
											if (resultPart.packetsLost == -1) result.outgoingStreams.audio = resultPart;
											else result.incomingStreams.audio = resultPart;
										} else {
											if (resultPart.packetsLost == -1) result.outgoingStreams.video = resultPart;
											else result.incomingStreams.video = resultPart;
										}
									}
								}
							}
							callbackFn(result);
						}, function (error) {
							console.log("Error received " + error);
						});
					}
				} else if (this.peerConnection && this.peerConnection.getRemoteStreams()[0] && webrtcDetectedBrowser == "firefox") {
					if (this.peerConnection.getStats) {
						this.peerConnection.getStats(null, function (rawStats) {
							var result = {type:"firefox", outgoingStreams: {}, incomingStreams: {}};
							for (var k in rawStats) {
								if (rawStats.hasOwnProperty(k)) {
									var resultPart = me.processRtcStatsReport(rawStats[k]);
									if (resultPart != null) {
										if (resultPart.type == "outboundrtp") {
											if (resultPart.id.indexOf("audio") > -1) result.outgoingStreams.audio = resultPart;
											else result.outgoingStreams.video = resultPart;
										} else if (resultPart.type == "inboundrtp") {
											if (resultPart.id.indexOf("audio") > -1) result.incomingStreams.audio = resultPart;
											else result.incomingStreams.video = resultPart;
										}
									}
								}
							}
							callbackFn(result);
						}, function (error) {
							console.log("Error received " + error);
						});
					}
				}
			};
			this.processRtcStatsReport = function (report) {
				/**
				 * RTCStatsReport http://mxr.mozilla.org/mozilla-central/source/dom/webidl/RTCStatsReport.webidl
				 */
				var result = null;
				if (report.type && (report.type == "outboundrtp" || report.type == "inboundrtp") && report.id.indexOf("rtcp") == -1) {
					result = {};
					for (var k in report) {
						if (report.hasOwnProperty(k)) result[k] = report[k];
					}
				}
				return result;
			};
			this.processGoogRtcStatsReport = function (report) {
				/**
				 * Report types: googComponent, googCandidatePair, googCertificate, googLibjingleSession, googTrack, ssrc
				 */
				if (report.type && (report.type == "ssrc" || (report.type == "googCandidatePair" && report.stat("googActiveConnection") == "true"))) {
					var result = {
						timestamp : report.timestamp,
						id : report.id,
						type : report.type	
					};
					if (report.names) {
						var names = report.names();
						for (var i = 0; i < names.length; ++i) {
							var attrName = names[i];
							result[attrName] = report.stat(attrName);
						}
					}
				}
				return null;
			};
			this.onCreateAnswerErrorCallback = function (error) {
				if(SDK.debug) console.error("WebRtcMediaConnection - onCreateAnswerErrorCallback(): error: " + error);
			};
			this.onCreateOfferErrorCallback = function (error) {
				if(SDK.debug) console.error("WebRtcMediaConnection - onCreateOfferErrorCallback(): error: " + error);
			};
			this.onSetLocalDescriptionErrorCallback = function (error) {
				if(SDK.debug) console.error("WebRtcMediaConnection - onSetLocalDescriptionErrorCallback(): error: " + error);
			};
			this.onSetRemoteDescriptionErrorCallback = function (error) {
				if(SDK.debug) console.error("WebRtcMediaConnection - onSetRemoteDescriptionErrorCallback(): error: " + error);
			};
		}
		, SoundControl = new function () {
			me = this;
			function initSound(src, loop, preload) {
				if (typeof loop == 'undefined') loop = false;
				var audioTag = document.createElement("audio");
				audioTag.autoplay = false;
				audioTag.preload = preload;
				if (loop) audioTag.loop = true;
				audioTag.src = APIFO_PATH+'/'+src;
				document.body.appendChild(audioTag);
				return audioTag;
			}
			//Init sounds
			me.registerSound = initSound(Configuration.registerSound, false, "auto");
			me.messageSound = initSound(Configuration.messageSound, false, "auto");
			me.ringSound = initSound(Configuration.ringSound, true, "none");
			me.busySound = initSound(Configuration.busySound, false, "none");
			me.finishSound = initSound(Configuration.finishSound, false, "none");
			this.playSound = function (soundName) {
				//soundName.toLowerCase()
				switch (soundName) {
					case "RING": if(Configuration.disableLocalRing) break;
					case "BUSY": case "REGISTER": case "FINISH": case "MESSAGE":
						me[soundName.toLowerCase()+'Sound'].play();
					break;
					default: console.error("Do not know what to play on " + soundName);
				}
			}
			this.stopSound = function (soundName) {
				switch (soundName) {
					case "RING":
						if (me.ringSound && !me.ringSound.paused) {
							me.ringSound.pause();
							try{
								me.ringSound.currentTime = 0;
							} catch(err){
								console.log(err);
							}
						}
						break;
					default:
						console.error("Do not know what to stop on " + soundName);
				}
			}
		}
		, app=this;
		app.flashphoner=new function(){
			var self=this;
			var flash_load_interval;
			self = {
				mediaProvider:null,//current mediaProvider
				configuration : Configuration,
				webRtcCallSessionId : undefined,
				flashMediaManager : undefined,
				connection : null,
				webRtcMediaManager : {
					webRtcMediaConnections : new DataMap(),
					isAudioMuted : 1,
					isVideoMuted : 1,
					remoteSDP : {},
					getVolume : function (id) {
						return this.webRtcMediaConnections.get(id).remoteMediaElement.volume;
					},
					setVolume : function (id, volume) {
						this.webRtcMediaConnections.get(id).remoteMediaElement.volume = volume / 100;
					},
					mute : function () {
						if (this.localAudioStream) this.localAudioStream.getAudioTracks()[0].enabled = false;
						if (this.localAudioVideoStream) this.localAudioVideoStream.getAudioTracks()[0].enabled = false;
					},
					unmute : function () {
						if (this.localAudioStream) this.localAudioStream.getAudioTracks()[0].enabled = true;
						if (this.localAudioVideoStream) this.localAudioVideoStream.getAudioTracks()[0].enabled = true;
					},
					hasAccessToAudio : function () {
						return this.isAudioMuted == -1;
					},
					hasAccessToAudioAndVideo : function () {
						return this.isVideoMuted == -1;
					},
					newConnection : function (id, webRtcMediaConnection) {
						if (this.remoteSDP[id]) {
							webRtcMediaConnection.setRemoteSDP(this.remoteSDP[id], false);
							delete this.remoteSDP[id];
						}
						this.webRtcMediaConnections.add(id, webRtcMediaConnection);
					},
					receivedEmptyRemoteSDP : function (id) {
						var webRtcMediaConnection = this.webRtcMediaConnections.get(id);
						return !webRtcMediaConnection || webRtcMediaConnection.lastReceivedSdp == "";
					},
					createOffer : function (id, callback, hasAudio, hasVideo, receiveVideo) {
						var connection=self.webRtcMediaManager.webRtcMediaConnections.get(id);
						if(connection)connection.createOffer(callback, hasAudio, hasVideo, receiveVideo);
						else if(SDK.debug)console.log('Connection',connection,'not exist');
					},
					createAnswer : function (id, callback, hasVideo) {
						this.webRtcMediaConnections.get(id).createAnswer(callback, hasVideo);
					},
					setRemoteSDP : function (id, sdp, isInitiator) {
						var webRtcMediaConnection = this.webRtcMediaConnections.get(id);
						if (webRtcMediaConnection) webRtcMediaConnection.setRemoteSDP(sdp, isInitiator);
						else this.remoteSDP[id] = sdp;
					},
					getStatistics : function (callId, callbackFn) {
						this.webRtcMediaConnections.get(callId).getStatistics(callbackFn);
					},
					setAudioCodec : function (id, codec) { },
					talk : function (callId, hasVideo) { },
					hold : function (callId) { },
					close : function (id) {
						this.webRtcMediaConnections.remove(id).close();
					},
					disconnect : function () {
						for (var id in this.webRtcMediaConnections.getData()) {
							this.webRtcMediaConnections.remove(id).close();
						}
					},
					getAccessToAudioAndVideo : function () {
						var me = this;
						if (!me.localAudioVideoStream) {
							var videoConstraints = {
								mandatory: {
									maxWidth: app.flashphoner.configuration.videoWidth,
									maxHeight: app.flashphoner.configuration.videoHeight
								},
								optional: []
							};
							if (app.flashphoner.configuration.forceResolution) {
								videoConstraints.mandatory.minWidth = app.flashphoner.configuration.videoWidth;
								videoConstraints.mandatory.minHeight = app.flashphoner.configuration.videoHeight;
							}
							getUserMedia({audio: true, video: videoConstraints}, function (stream) {
								var localMediaElement = document.getElementById(app.flashphoner.configuration.localMediaElementId);
								if (localMediaElement) attachMediaStream(localMediaElement, stream);
								me.localAudioVideoStream = stream;
								me.isAudioMuted = -1;
								me.isVideoMuted = -1;
							}, function (error) {
								if(SDK.debug) console.log("Failed to get access to local media. Error code was " + error.code + ".");
								me.isAudioMuted = 1;
								me.isVideoMuted = 1;
								var status = {
									status: "MIC_CAM_ACCESS_PROBLEM",
									info: "Failed to get access to microphone and camera. Error code was " + error.code + "."
								};
								app.flashphoner.invokeProblem(status);
							}
							);
						}
						return true;
					},
					getAccessToAudio : function () {
						var me = this;
						if (!me.localAudioStream) {
							getUserMedia({audio: true}, function (stream) {
								me.localAudioStream = stream;
								me.isAudioMuted = -1;
							}, function (error) {
								var status = {
									status: "MIC_ACCESS_PROBLEM",
									info: "Failed to get access to microphone. Error code was " + error.code + "."
								};
								app.flashphoner.invokeProblem(status);
								me.isAudioMuted = 1;
							});
						}
						return true;
					}
				},
				calls : new DataMap(),
				publishStreams : new DataMap(),
				playStreams : new DataMap(),
				messages : {},
				isOpened : false,
				listeners : {},
				version : undefined,
				mediaProviders : new DataMap(),
				intervalId : -1,
				firefoxCodecReplaicer : {"pcma":"PCMA", "pcmu":"PCMU", "g722":"G722", "OPUS":"opus", "SHA-256":"sha-256"},
				initFlash: function () {
					//todo: Check flash avaliable
					start=Date.now();
					var flashVideoDiv = document.createElement('div'),
					u=navigator.userAgent,wmode=((u.indexOf("Safari") != -1 && u.indexOf("Chrome") == -1) || (u.indexOf("Mozilla") + u.indexOf("Firefox") != -2))?"window":"transparent";
					
					flashVideoDiv.style.width = '322px';
					flashVideoDiv.style.height = '176px';
					flashVideoDiv.innerHTML='<object id="'+self.configuration.elementIdForSWF+'" type="application/x-shockwave-flash" data="'+APIFO_PATH+self.configuration.pathToSWF+'" width="100%" height="100%" style="visibility: visible;"><param name="menu" value="true"><param name="swliveconnect" value="true"><param name="allowfullscreen" value="true"><param name="allowscriptaccess" value="always"><param name="wmode" value="'+wmode+'"></object>';
					document.body.appendChild(flashVideoDiv);
					self.flashMediaManager=document.getElementById(self.configuration.elementIdForSWF);
					self.mediaProviders.add(MediaProvider.Flash, self.flashMediaManager);
					flash_load_interval=setInterval(function(){
						if(typeof self.flashMediaManager.connect == 'function'){
							clearInterval(flash_load_interval);
							flash_load_interval=false;
							if(SDK.debug) console.log('flashMediaManager ready',(Date.now()-start)/1000);
							self.mediaProviders.add(MediaProvider.Flash, self.flashMediaManager);
							self.mediaProvider = MediaProvider.Flash;
							if (self.flashMediaManager) self.initFlashMediaManager();
							if(self.connection) self.invokeListener(WCSEvent.ConnectionStatusEvent, [ self.connection ]);
						}else{
							if(SDK.debug) console.log('flashMediaManager not ready');
						}
					},777);
				},
				initFlashMediaManager: function () {
					if (self.userData) self.flashMediaManager.connect(self.configuration.urlFlashServer, self.userData, self.configuration);
				},
				initWebRTC: function () {
					if (navigator.mozGetUserMedia) {
						console.log("This appears to be Firefox");
						if (typeof(mozRTCPeerConnection) === undefined) {
							if(SDK.debug)console.log("Please, update your browser to use WebRTC");
							return false;
						} else {
							self.mediaProviders.add(MediaProvider.WebRTC, self.webRtcMediaManager);
							webrtcDetectedBrowser = "firefox";
							RTCPeerConnection = mozRTCPeerConnection;
							RTCSessionDescription = mozRTCSessionDescription;
							RTCIceCandidate = mozRTCIceCandidate;
							getUserMedia = navigator.mozGetUserMedia.bind(navigator);
							attachMediaStream = function (element, stream) {
								element.mozSrcObject = stream;
								element.play();
							};
							reattachMediaStream = function (to, from) {
								to.mozSrcObject = from.mozSrcObject;
								to.play();
							};
							return true;
						}
					} else if (navigator.webkitGetUserMedia) {
						if (typeof(webkitRTCPeerConnection) === undefined) {
							if(SDK.debug)console.log("Please, update your browser to use WebRTC");
							return false;
						} else {
							self.mediaProviders.add(MediaProvider.WebRTC, self.webRtcMediaManager);
							webrtcDetectedBrowser = "chrome";
							RTCPeerConnection = webkitRTCPeerConnection;
							getUserMedia = navigator.webkitGetUserMedia.bind(navigator);
							attachMediaStream = function (element, stream) {
								element.src = URL.createObjectURL(stream);
								element.play();
							};
							reattachMediaStream = function (to, from) {
								to.src = from.src;
								element.play();
							};
							return true;
						}
					} else {
						console.warn("Browser does not appear to be WebRTC-capable");
						return false;
					}
				},
				
				addListener: function (event, listener) {
					this.listeners[event] = listener;
				},
				invokeListener: function (event, argsArray) {
					if(SDK.debug)console.log('invoke listener',event,argsArray);
					var listener = this.listeners[event];
					if (listener)listener.apply(SDK, argsArray);
				},
				
				addOrUpdateCall: function (call) {
					if (self.calls.get(call.callId)) {
						self.calls.update(call.callId, call);
					} else {
						self.calls.add(call.callId, call);
						if (call.incoming || call.parentCallId !== undefined) self.invokeListener(WCSEvent.OnCallEvent, [ call ]);
						if (!call.mediaProvider) call.mediaProvider = Object.keys(app.flashphoner.mediaProviders.getData())[0];
						if (!this.webRtcCallSessionId && MediaProvider.WebRTC==call.mediaProvider) {
							this.webRtcCallSessionId = call.callId;
							self.webRtcMediaManager.newConnection(call.callId, new WebRtcMediaConnection(self.webRtcMediaManager, self.configuration.stunServer, self.configuration.useDTLS | true, self.configuration.remoteMediaElementId));
						}
					}
				},
				removeSentMessage: function (sentMessage) {
					setTimeout(function () {
						self.messages[sentMessage.id] = null;
					}, 5000);
				},
				connect: function (login,password) {
					self.connection = {
						urlServer : self.configuration.urlWsServer,
						sipRegisterRequired : true,
						sipContactParams : self.configuration.sipContactParams,
						status : "PENDING",
						width : self.configuration.videoWidth,
						height : self.configuration.videoHeight,
						sipLogin : login,
						sipPassword : password,
						sipAuthenticationName : login,
						sipDomain : self.configuration.sipDomain,
						sipOutboundProxy : self.configuration.sipDomain,
						sipPort : self.configuration.sipPort,
						appKey : self.configuration.appKey
					}


					if (!self.connection.mediaProviders || self.connection.mediaProviders.length == 0) self.connection.mediaProviders = Object.keys(self.mediaProviders.getData());

					//workaround for old Safari (5.X)
					if ((navigator.userAgent.indexOf("Safari") > -1) && !(navigator.userAgent.indexOf("Chrome") > -1)) {
						self.connection.urlServer = self.connection.urlServer.slice(-1) == "/" ? self.connection.urlServer + "websocket" : self.connection.urlServer + "/websocket";
					}
					var l = document.createElement("a");
					l.href = self.connection.urlServer;
					if (!self.configuration.urlFlashServer) self.configuration.urlFlashServer = "rtmfp://" + l.hostname + ":1935";
					self.webSocket = new WebSocket(self.connection.urlServer);
					self.webSocket.binaryType = 'arraybuffer';
					self.webSocket.onopen=function () {
						self.isOpened = true;
						self.webSocket.send("connection", self.connection);
					};
					self.webSocket.onmessage=function (event) {
						if (event.data instanceof ArrayBuffer) {
							h = self.callbacks["binaryData"];
							if (h) h.apply(self, [event]);
						} else {
							var m = JSON.parse(event.data);
							h = self.callbacks[m.message];
							if (h) h.apply(self, m.data);
						}
					};
					self.webSocket.onerror=function (error) {
						console.error(error);
						self.connection.status = ConnectionStatus.Failed;
						self.invokeListener(WCSEvent.ConnectionStatusEvent, [ self.connection ]);
					};
					self.webSocket.onclose=function (event) {
						self.isOpened = false;
						if (!event.wasClean) self.connection.status = ConnectionStatus.Failed;
						else self.connection.status = ConnectionStatus.Disconnected;
						self.invokeListener(WCSEvent.ConnectionStatusEvent, [ self.connection, event ]);
						if (self.webRtcMediaManager) self.webRtcMediaManager.disconnect();
						if (self.flashMediaManager) self.flashMediaManager.disconnect();
						self.webRtcCallSessionId = undefined;
						self.calls = new DataMap();
					};
					self.webSocket._send = self.webSocket.send;
					self.webSocket.send = function (message, data) {
						if (self.webSocket.readyState == 1) {
							var m = {message: message};
							if (!(data == null || typeof data === "undefined")) m['data'] = [data];
							return this._send(JSON.stringify(m));
						}
						return false;
					};
					window.onunload=function () {
						self.webSocket.close();
						self.webSocket = null
					};
					return 0;
				},
				invokeProblem: function (status) {
					this.invokeListener(WCSEvent.ErrorStatusEvent, [ status ]);
				},
				disconnect: function () {
					if(SDK.debug)console.log("WebSocketManager - disconnect");
					this.webSocket.close();
				},
				subscribe: function (subscribeObject) {
					this.webSocket.send("subscribe", subscribeObject);
				},
				sendXcapRequest: function (xcapObject) {
					this.webSocket.send("sendXcapRequest", xcapObject);
				},
				call: function (call) {
					call.callId = createUUID();
					call.incoming = false;
					if (!call.isMsrp) call.isMsrp = false;
					if (!call.hasVideo) call.hasVideo = false;
					self.addOrUpdateCall(call);
					self.checkAndGetAccess(call.mediaProvider, call.hasVideo, function () {
						if (MediaProvider.WebRTC == call.mediaProvider) {
							self.webRtcMediaManager.createOffer(call.callId, function (sdp) {
								//here we will strip codecs from SDP if requested
								if (self.configuration.stripCodecs && self.configuration.stripCodecs.length > 0) {
									sdp = self.stripCodecsSDP(sdp);
									if(SDK.debug)console.log("New SDP: " + sdp);
								}
								sdp = self.removeCandidatesFromSDP(sdp);
								call.sdp = sdp;
								self.webSocket.send("call", call);
							}, true, call.hasVideo);
						} else if (MediaProvider.Flash == call.mediaProvider) {
							self.webSocket.send("call", call);
						}
					}, []);
					return call;
				},
				msrpCall: function (callRequest) {
					callRequest.callId = createUUID();
					self.webSocket.send("call", callRequest);
					return callRequest;
				},
				answer: function (call) {
					self.checkAndGetAccess(call.mediaProvider, call.hasVideo, function () {
						if (MediaProvider.WebRTC == call.mediaProvider) {
							/**
							 * If we receive INVITE without SDP, we should send answer with SDP based on webRtcMediaManager.createOffer because we do not have remoteSdp here
							 */
							if (self.webRtcMediaManager.receivedEmptyRemoteSDP(call.callId)) {
								self.webRtcMediaManager.createOffer(call.callId, function (sdp) {
									//here we will strip codecs from SDP if requested
									if (self.configuration.stripCodecs && self.configuration.stripCodecs.length > 0) {
										sdp = self.stripCodecsSDP(sdp);
										if(SDK.debug)console.log("New SDP: " + sdp);
									}
									call.sdp = self.removeCandidatesFromSDP(sdp);
									self.webSocket.send("answer", call);
								}, true, call.hasVideo);
							} else {
								/**
								 * If we receive a normal INVITE with SDP we should create answering SDP using normal createAnswer method because we already have remoteSdp here.
								 */
								self.webRtcMediaManager.createAnswer(call.callId, function (sdp) {
									call.sdp = sdp;
									self.webSocket.send("answer", call);
								}, call.hasVideo);
							}
						} else if (MediaProvider.Flash == call.mediaProvider) {
							self.webSocket.send("answer", call);
						}
					}, []);
				},
				changeVideoState: function (call, enable) {
					if (MediaProvider.Flash == call.mediaProvider) {
						if (!call.hasVideo) {
							self.webSocket.send("updateCallToVideo", call.callId);
							call.hasVideo = true;
						}
						self.flashMediaManager.changeVideoState(call.callId, enable);
					} else {
						/*
						todo uncomment after firefox implement reoffer
						this.webRtcMediaManager.createOffer(call.callId, function (sdp) {
							self.webSocket.send("changeVideoState", {callId: call.callId, sdp: sdp});
						}, true, call.hasVideo);
						*/
					}
					return 0;
				},
				hangup: function (call) {
					if (call) self.webSocket.send("hangup", {callId: call.callId});
				},
				hold: function (call) {
					this.webSocket.send("hold", {callId: call.callId});
				},
				unhold: function (call) {
					this.webSocket.send("unhold", {callId: call.callId});
				},
				transfer: function (transferObj) {
					this.webSocket.send("transfer", transferObj);
				},
				sendDTMF: function (dtmfObj) {
					if (!dtmfObj.type) dtmfObj.type = "RFC2833";
					this.webSocket.send("sendDtmf", dtmfObj);
				},
				getCallStatistics: function (call, callbackFn) {
					if (MediaProvider.Flash == call.mediaProvider) this.getStreamStatistics(call.callId, call.mediaProvider, callbackFn);
					else this.getStreamStatistics(this.webRtcCallSessionId, call.mediaProvider, callbackFn);
				},
				getStreamStatistics: function (mediaSessionId, mediaProvider, callbackFn) {
					if (MediaProvider.Flash == mediaProvider) {
						var statistics = this.flashMediaManager.getStatistics(mediaSessionId);
						var param;
						for (param in statistics.incomingStreams.info){
							if (param.indexOf("audio") > -1) statistics.incomingStreams.audio[param] = statistics.incomingStreams.info[param];
							if (param.indexOf("video") > -1) statistics.incomingStreams.video[param] = statistics.incomingStreams.info[param];
						}
						delete statistics.incomingStreams.info;
						for (param in statistics.outgoingStreams.info){
							if (param.indexOf("audio") > -1) statistics.outgoingStreams.audio[param] = statistics.outgoingStreams.info[param];
							if (param.indexOf("video") > -1) statistics.outgoingStreams.video[param] = statistics.outgoingStreams.info[param];
						}
						delete statistics.outgoingStreams.info;
						statistics.type = "flash";
						callbackFn(statistics);
					} else this.webRtcMediaManager.getStatistics(mediaSessionId, callbackFn);
				},
				setUseProxy: function (useProxy) {
					if (this.isOpened) this.webSocket.send("setUseProxy", useProxy);
				},
				pushLogs: function (logsObject) {
					if (this.isOpened) this.webSocket.send("pushLogs", logsObject);
					return !!this.isOpened;
				},
				submitBugReport: function (reportObject) {
					if (this.isOpened) this.webSocket.send("submitBugReport", reportObject);
					return !!this.isOpened;
				},
				setLTState: function (state) {
					if(SDK.debug)console.log("setLTState: " + state);
					this.webSocket.send("setLTState", {state: state});
				},
				getAccess: function (mediaProvider, hasVideo) {
					mediaProvider = mediaProvider || self.mediaProvider;
					setTimeout(function () {
						if (hasVideo) {
							if (!self.mediaProviders.get(mediaProvider||self.mediaProvider).getAccessToAudioAndVideo()) 
							self.invokeProblem({
								status: "MIC_CAM_ACCESS_PROBLEM",
								info: "Failed to get access to microphone or not found"
							});
						} else {
							if (!self.mediaProviders.get(mediaProvider||self.mediaProvider).getAccessToAudio())
							self.invokeProblem({
								status: "MIC_ACCESS_PROBLEM",
								info: "Failed to get access to microphone and camera or not found"
							});
						}
					}, 50);
				},
				hasAccess: function (mediaProvider, hasVideo) {
					var mp = self.mediaProviders.get(mediaProvider||self.mediaProvider);
					if(hasVideo) return mp.hasAccessToAudioAndVideo && mp.hasAccessToAudioAndVideo();
					else return mp.hasAccessToAudio && mp.hasAccessToAudio();
				},
				checkAndGetAccess: function (mediaProvider, hasVideo, func, args) {
					if (args === undefined) args = [];
					if (!this.hasAccess(mediaProvider, hasVideo)) {
						if (this.intervalId == -1) {
							var checkAccessFunc = function () {
								if (self.hasAccess(mediaProvider, hasVideo)) {
									clearInterval(self.intervalId);
									self.intervalId = -1;
									self.checkAndGetAccess(mediaProvider, hasVideo, func, args);
								}
							};
							this.intervalId = setInterval(checkAccessFunc, 500);
						}
						this.getAccess(mediaProvider, hasVideo);
					} else if (this.hasAccess(mediaProvider, hasVideo)) {
						func.apply(this, args);
					} else {
						if(SDK.debug)console.log("Microphone is not plugged in");
					}
				},
				getVolume: function (call) {
					return this.mediaProviders.get(call.mediaProvider).getVolume(call.callId);
				},
				setVolume: function (call, value) {
					this.mediaProviders.get(call.mediaProvider).setVolume(call.callId, value);
				},
				mute: function (mediaProvider) {
					if (!mediaProvider) mediaProvider = Object.keys(app.flashphoner.mediaProviders.getData())[0];
					this.mediaProviders.get(mediaProvider).mute();
				},
				unmute: function (mediaProvider) {
					if (!mediaProvider) mediaProvider = Object.keys(app.flashphoner.mediaProviders.getData())[0];
					this.mediaProviders.get(mediaProvider).unmute();
				},
				sendMessage: function (message) {
					var id = createUUID();
					message.id = id;
					message.from = this.userData.sipLogin;
					message.contentType = message.contentType || this.configuration.msgContentType;
					message.isImdnRequired = message.isImdnRequired || this.configuration.imdnEnabled;
					this.messages[id] = message;
					this.webSocket.send("sendMessage", message);
				},
				notificationResult: function (result) {
					this.webSocket.send("notificationResult", result);
				},
				sendData: function (data) {
					this.webSocket.send("sendData", data);
				},
				publishStream: function (stream) {
					var mediaSessionId = createUUID();
					stream.mediaSessionId = mediaSessionId;
					stream.published = true;
					if (stream.hasVideo == undefined) stream.hasVideo = true;
					self.checkAndGetAccess(MediaProvider.WebRTC, stream.hasVideo, function () {
						self.webRtcMediaManager.newConnection(mediaSessionId, new WebRtcMediaConnection(self.webRtcMediaManager, self.configuration.stunServer, self.configuration.useDTLS | true, self.configuration.remoteMediaElementId));
						self.webRtcMediaManager.createOffer(mediaSessionId, function (sdp) {
							if(SDK.debug)console.log("Publish name " + stream.name);
							if (self.configuration.stripCodecs && self.configuration.stripCodecs.length > 0) {
								sdp = self.stripCodecsSDP(sdp);
								if(SDK.debug)console.log("New SDP: " + sdp);
							}
							stream.sdp = self.removeCandidatesFromSDP(sdp);
							self.webSocket.send("publishStream", stream);
							self.publishStreams.add(stream.name, stream);
						}, true, stream.hasVideo);
					}, []);
				},
				unPublishStream: function (stream) {
					if(SDK.debug)console.log("Unpublish stream " + stream.name);
					var removedStream = self.publishStreams.remove(stream.name);
					self.webRtcMediaManager.close(removedStream.mediaSessionId);
					self.webSocket.send("unPublishStream", removedStream);
				},
				playStream: function (stream) {
					if (self.playStreams.get(stream.name) != null) {
						if(SDK.debug)console.log("Request resume for stream " + stream.name);
						self.webSocket.send("playStream", stream);
						return;
					}
					var mediaSessionId = createUUID();
					if (!stream.sdp) {
						self.webRtcMediaManager.newConnection(mediaSessionId, new WebRtcMediaConnection(self.webRtcMediaManager, self.configuration.stunServer, self.configuration.useDTLS | true, stream.remoteMediaElementId || self.configuration.remoteMediaElementId));
						stream.mediaSessionId = mediaSessionId;
						stream.published = false;
						if (stream.hasVideo == undefined) stream.hasVideo = true;
						self.webRtcMediaManager.createOffer(mediaSessionId, function (sdp) {
							if(SDK.debug)console.log("playStream name " + stream.name);
							if (self.configuration.stripCodecs && self.configuration.stripCodecs.length > 0) {
								sdp = self.stripCodecsSDP(sdp);
								if(SDK.debug)console.log("New SDP: " + sdp);
							}
							stream.sdp = self.removeCandidatesFromSDP(sdp);
							self.webSocket.send("playStream", stream);
							self.playStreams.add(stream.name, stream);
						}, false, false, stream.hasVideo);
					} else {
						if(SDK.debug)console.log("playStream name " + stream.name);
						stream.mediaSessionId = mediaSessionId;
						stream.published = false;
						self.webSocket.send("playStream", stream);
						self.playStreams.add(stream.name, stream);
					}
					return stream;
				},
				stopStream: function (stream) {
					if(SDK.debug)console.log("unSubscribe stream " + stream.name);
					var removedStream = self.playStreams.remove(stream.name);
					self.webRtcMediaManager.close(removedStream.mediaSessionId);
					self.webSocket.send("stopStream", removedStream);
				},
				//Works only with websocket streams
				pauseStream: function (stream) {
					if(SDK.debug)console.log("Pause stream " + stream.name);
					self.webSocket.send("pauseStream", stream);
				},
				removeCandidatesFromSDP: function (sdp) {
					var sdpArray = sdp.split("\n");
					for (i = 0; i < sdpArray.length; i++) {
						if (sdpArray[i].search("a=candidate:") != -1) sdpArray[i] = "";
					}
					//normalize sdp after modifications
					var result = "";
					for (i = 0; i < sdpArray.length; i++) {
						if (sdpArray[i] != "") result += sdpArray[i] + "\n";
					}
					return result;
				},
				stripCodecsSDP: function (sdp) {
					var sdpArray = sdp.split("\n");
					//search and delete codecs line
					var pt = [];
					for (p = 0; p < this.configuration.stripCodecs.length; p++) {
						if(SDK.debug)console.log("Searching for codec " + this.configuration.stripCodecs[p]);
						for (i = 0; i < sdpArray.length; i++) {
							if (sdpArray[i].search(this.configuration.stripCodecs[p]) != -1 && sdpArray[i].indexOf("a=rtpmap") == 0) {
								if(SDK.debug)console.log(this.configuration.stripCodecs[p] + " detected");
								pt.push(sdpArray[i].match(/[0-9]+/)[0]);
								sdpArray[i] = "";
							}
						}
					}
					if (pt.length) {
						//searching for fmtp
						for (p = 0; p < pt.length; p++) {
							for (i = 0; i < sdpArray.length; i++) {
								if (sdpArray[i].search("a=fmtp:" + pt[p]) != -1) {
									if(SDK.debug)console.log("PT " + pt[p] + " detected");
									sdpArray[i] = "";
								}
								if (sdpArray[i].search("a=candidate:") != -1) sdpArray[i] = "";
							}
						}
						//delete entries from m= line
						for (i = 0; i < sdpArray.length; i++) {
							if (sdpArray[i].search("m=audio") != -1) {
								if(SDK.debug)console.log("m line detected " + sdpArray[i]);
								var mLineSplitted = sdpArray[i].split(" ");
								var newMLine = "";
								for (m = 0; m < mLineSplitted.length; m++) {
									if (pt.indexOf(mLineSplitted[m]) == -1 || m <= 2) {
										newMLine += mLineSplitted[m];
										if (m < mLineSplitted.length - 1) newMLine = newMLine + " ";
									}
								}
								sdpArray[i] = newMLine;
								if(SDK.debug)console.log("Resulting m= line is: " + sdpArray[i]);
								break;
							}
						}
					}
					//normalize sdp after modifications
					var result = "";
					for (i = 0; i < sdpArray.length; i++) {
						if (sdpArray[i] != "") result += sdpArray[i] + "\n";
					}
					return result;
				},
				handleVideoSSRC: function (sdp) {
					var sdpArray = sdp.split("\n");
					var videoPart = false;
					var recvonly = false;
					var ssrcPos = -1;
					for (i = 0; i < sdpArray.length; i++) {
						if (sdpArray[i].search("m=video") != -1) videoPart = true;
						if (sdpArray[i].search("a=ssrc") != -1 && videoPart) ssrcPos = i;
						if (sdpArray[i].search("a=recvonly") != -1 && videoPart) recvonly = true;
						if (sdpArray[i].search("m=audio") != -1 && videoPart) break;
					}
					if (recvonly && ssrcPos != -1) sdpArray[ssrcPos] = "";
					//normalize sdp after modifications
					var result = "";
					for (i = 0; i < sdpArray.length; i++) {
						if (sdpArray[i] != "") result += sdpArray[i] + "\n";
					}
					return result;
				},
				getCookie: function (c_name) {
					var i, x, y, ARRcookies = document.cookie.split(";");
					for (i = 0; i < ARRcookies.length; i++) {
						x = ARRcookies[i].substr(0, ARRcookies[i].indexOf("="));
						x = x.replace(/^\s+|\s+$/g, "");
						if (x == c_name) return ARRcookies[i].substr(ARRcookies[i].indexOf("=") + 1);
					}
					return "";
				},
				setCookie: function (c_name, value) {
					var exdate = new Date();
					exdate.setDate(exdate.getDate() + 100);
					var c_value = escape(value) + "; expires=" + exdate.toUTCString();
					document.cookie = c_name + "=" + c_value;
					return value;
				}
			}
			
			if (!self.configuration.remoteMediaElementId) {
				self.configuration.remoteMediaElementId = 'remoteMediaElement';
				var _body = document.getElementsByTagName('body') [0];
				var remoteMediaElement = document.createElement('audio');
				remoteMediaElement.id = self.configuration.remoteMediaElementId;
				_body.appendChild(remoteMediaElement);
			}
			if(!self.initWebRTC()){
				console.log('WebRTC not active, try to load flash');
				self.initFlash();				
			}else{
				//console.log('WebRTC ready');
				self.mediaProvider=MediaProvider.WebRTC;
			}
			if (self.configuration.localMediaElementId) documenht.getElementById(self.configuration.localMediaElementId).volume = 0;
			
			self.callbacks = {
				ping: function () {
					self.webSocket.send("pong");
				},
				getUserData: function (userData) {
					if(SDK.debug)console.log('getuserdata',userData);
					self.userData = userData;
					for (var prop in userData) {
						self.connection[prop] = self.userData[prop];
					}
					self.connection.status = ConnectionStatus.Established;
					if(self.mediaProvider){
						self.invokeListener(WCSEvent.ConnectionStatusEvent, [ self.connection ]);	
					}
				},
				getVersion: function (version) {
					self.version = version;
				},
				registered: function (event) {
					self.invokeListener(WCSEvent.RegistrationStatusEvent, [ event ]);
				},
				notifyIncomingCall: function (call) {
					if(SDK.debug)console.log("notifyIncomingCall call.callId:" + call.callId);
					self.addOrUpdateCall(call);
				},
				notifyTransferEvent: function (call) {
					if(SDK.debug)console.log("notifyTransferEvent " + call.status);
					if (call.status == "PENDING") self.invokeListener(WCSEvent.OnTransferEvent, [ call ]);
					else self.invokeListener(WCSEvent.TransferStatusEvent, [ call ]);
				},
				notifyTryingResponse: function (call) {
					if(SDK.debug)console.log("notifyTryingResponse call.callId:" + call.callId);
					self.addOrUpdateCall(call);
					self.invokeListener(WCSEvent.CallStatusEvent, [ call ]);
				},
				ring: function (call) {
					if(SDK.debug)console.log("ring call.status: " + call.status + " call.callId: " + call.callId);
					self.addOrUpdateCall(call);
					self.invokeListener(WCSEvent.CallStatusEvent, [ call ]);
				},
				sessionProgress: function (call) {
					if(SDK.debug)console.log("sessionProgress call.state: " + call.state + " call.callId: " + call.callId);
					self.addOrUpdateCall(call);
					self.invokeListener(WCSEvent.CallStatusEvent, [ call ]);
				},
				setRemoteSDP: function (id, sdp, isInitiator) {
					if (self.webRtcMediaManager) {
						if (navigator.mozGetUserMedia) {
							for (var c in self.firefoxCodecReplaicer){
								sdp = sdp.split(c).join(self.firefoxCodecReplaicer[c]);
							}
						}
						self.webRtcMediaManager.setRemoteSDP(id, sdp, isInitiator);
					}
				},
				notifyAudioCodec: function (id, codec) {
					var call = self.calls.get(id);
					if (self.flashMediaManager && call && MediaProvider.Flash == call.mediaProvider) self.flashMediaManager.setAudioCodec(id, codec);
				},
				binaryData: function (data) {
					self.invokeListener(WCSEvent.OnBinaryEvent, [ data ]);
				},
				base64BinaryData: function (data) {
					var result = {};
					var raw = window.atob(data);
					var rawLength = raw.length;
					var array = new Uint8Array(new ArrayBuffer(rawLength));
					for(i = 0; i < rawLength; i++) {
						array[i] = raw.charCodeAt(i);
					}
					result.data = array;
					if(SDK.debug)console.log("received data length " + result.data.length);
					self.invokeListener(WCSEvent.OnBinaryEvent, [ result ]);
				},
				notifyVideoFormat: function (videoFormat) { },
				talk: function (call) {
					self.addOrUpdateCall(call);
					if (!call.isMsrp) self.mediaProviders.get(call.mediaProvider).talk(call.callId, call.hasVideo);
					self.invokeListener(WCSEvent.CallStatusEvent, [ call ]);
				},
				hold: function (call) {
					self.addOrUpdateCall(call);
					self.mediaProviders.get(call.mediaProvider).hold(call.callId);
					self.invokeListener(WCSEvent.CallStatusEvent, [ call ]);
				},
				callbackHold: function (callId, isHold) {
					if(SDK.debug)console.log("callbackHold " + isHold);
				},
				finish: function (call) {
					self.calls.remove(call.callId);
					if (self.calls.getSize() == 0 && MediaProvider.WebRTC == call.mediaProvider) {
						var sessionId = self.webRtcCallSessionId;
						self.webRtcCallSessionId = undefined;
						self.mediaProviders.get(call.mediaProvider).close(sessionId);
					}
					if (MediaProvider.Flash == call.mediaProvider) self.mediaProviders.get(call.mediaProvider).close(call.callId);
					self.invokeListener(WCSEvent.CallStatusEvent, [ call ]);
				},
				busy: function (call) {
					self.addOrUpdateCall(call);
					self.invokeListener(WCSEvent.CallStatusEvent, [ call ]);
				},
				fail: function (event) {
					if (event.hasOwnProperty("apiMethod")) {
						var actualEvent = WCSEvent[event.apiMethod];
						delete event.apiMethod;
						self.invokeListener(actualEvent, [ event ]);
					} else self.invokeListener(WCSEvent.ErrorStatusEvent, [ event ]);
				},
				notifyBugReport: function (filename) {
					self.invokeListener(WCSEvent.BugReportStatusEvent, [ {filename: filename} ]);
				},
				notifyMessage: function (message, notificationResult) {
					var sentMessage = self.messages[message.id];
					if (sentMessage != null) sentMessage.status = message.status;
					if (message.status == MessageStatus.RECEIVED) {
						//here we will choose what to display on multiple contacts in "from".
						if (message.from.indexOf(",") != -1) {
							var fromList = message.from.split(",");
							message.from = fromList[0];
						}
						notificationResult.status = "OK";
						self.notificationResult(notificationResult);
						self.invokeListener(WCSEvent.OnMessageEvent, [ message ]);
					} else {
						switch(message.status){
							case MessageStatus.ACCEPTED:
								if (!sentMessage.isImdnRequired) self.removeSentMessage(sentMessage);
							break;
							case MessageStatus.FAILED:
								self.removeSentMessage(sentMessage);
							break;
							case message.status == MessageStatus.IMDN_NOTIFICATION_SENT:
								if(!sentMessage)self.messages[message.id] = message;
							break;
							case message.status == MessageStatus.IMDN_DELIVERED:
								self.removeSentMessage(sentMessage);
								notificationResult.status = "OK";
								self.notificationResult(notificationResult);
							break;
							case MessageStatus.IMDN_FAILED: case MessageStatus.IMDN_FORBIDDEN: case MessageStatus.IMDN_ERROR:
								self.removeSentMessage(sentMessage);
								notificationResult.status = "OK";
								self.notificationResult(notificationResult);
							break;
						}
						self.invokeListener(WCSEvent.MessageStatusEvent, [ message ]);
					}
				},
				notifyRecordComplete: function (recordReport) {
					self.invokeListener(WCSEvent.RecordingStatusEvent, [ recordReport ]);
				},
				notifySubscription: function (subscription, sipObject) {
					self.invokeListener(WCSEvent.SubscriptionStatusEvent, [ subscription ]);
				},
				notifyXcapResponse: function (xcapResponse) {
					self.invokeListener(WCSEvent.XcapStatusEvent, [ xcapResponse ]);
				},
				notifyStreamStatusEvent: function (stream) {
					if (stream.published) self.publishStreams.update(stream.id, stream);
					else self.playStreams.update(stream.id, stream);
					self.invokeListener(WCSEvent.StreamStatusEvent, [ stream ]);
				},
				OnDataEvent: function (data) {
					self.invokeListener(WCSEvent.OnDataEvent, [ data ]);
					self.webSocket.send("DataStatusEvent", {status: "ACCEPTED", operationId: data.operationId});
				},
				DataStatusEvent: function (status) {
					self.invokeListener(WCSEvent.DataStatusEvent, [ status ]);
				}
			}
			return self;
		}
    }
	
	app.flashphoner.addListener(WCSEvent.ErrorStatusEvent, function (event) {
		var code = event.status;
		SDK.cancel();
		switch(code){
			case "MIC_ACCESS_PROBLEM": case "MIC_CAM_ACCESS_PROBLEM":
				if(SDK.debug) console.log(code,event.info);
			break;
			case "WRONG_SIPPROVIDER_ADDRESS":
			case "REST_AUTHORIZATION_FAIL":
			case "SIP_PORTS_BUSY":
			case "AUTHENTICATION_FAIL":
			case "INTERNAL_SIP_ERROR":
				setTimeout(SDK.disconnect, 3000);
			case "CONNECTION_ERROR":
			case "USER_NOT_AVAILABLE":
			case "LICENSE_RESTRICTION":
			case "LICENSE_NOT_FOUND":
			case "REGISTER_EXPIRE":
			case "MEDIA_PORTS_BUSY":
			case "CALLEE_NAME_IS_NULL":
			case "WRONG_FLASHPHONER_XML":
			case "PAYMENT_REQUIRED":
			case "REST_FAIL":
				if(SDK.debug)console.log(code);
			break;
		}
		listeners.error(event);
	});
	app.flashphoner.addListener(WCSEvent.ConnectionStatusEvent, function (event) {
		if(SDK.debug)console.log("Phone - Connection status ", event);
		switch(event.status){
			case ConnectionStatus.Disconnected: 
				SDK.currentCall = null;
				SDK.holdedCall = null;
				listeners.ready();
				console.log("Phone - Connection status: DISCONNECTED");				
				SDK.init(SDK.number,SDK.token, SDK.porta);
				console.log("Phone - Try to reconnect...");				
			break;
			case ConnectionStatus.Failed:
				SDK.currentCall = null;
				SDK.holdedCall = null;
				SDK.registered = false; 
				listeners.ready();
				console.log("Phone - Connection status: FAILED");				
			break;
			case ConnectionStatus.Established:
				//SDK.registered = true;// need 3th state beetwen true and false 
				//listeners.ready();
				console.log("Phone - Connection status: ESTABLISHED");
			break;
			case ConnectionStatus.Pending:
				//SDK.registered = true;// need 3th state beetwen true and false  
				console.log("Phone - Connection status: PENDING");
			break;			
			case ConnectionStatus.Registered:
				SDK.registered = true; 
				console.log("Phone - Connection status: REGISTERED");				
			break;						
		}
	});
	app.flashphoner.addListener(WCSEvent.RegistrationStatusEvent, function (event) {
		var status = event.status;
		var sipObject = event.sipMessageRaw;
		if(SDK.debug)console.log("Phone - registrationStatusListener " + status);
		switch(status){
			case "AUTHENTICATION_FAIL":
				SDK.registered = false;
				if(SDK.debug)console.log("Authentication failed, please check your SIP account details.");
				SDK.disconnect();
			break;
			case "FAILED":
				SDK.registered = false;
				if(SDK.debug)console.log("Phone - Register fail.");
				SDK.disconnect();
			break;
			case "UNREGISTERED":
				SDK.registered = false;
				if(SDK.debug)console.log("Unregistered from sip server.");
				SDK.disconnect();
			break;
			case "REGISTERED":
			        SDK.registered = true; 
				SoundControl.playSound("REGISTER");
				if (Configuration.subscribeEvent != null && Configuration.subscribeEvent.length != 0) SDK.subscribe();
				if (Configuration.xcapUrl)app.flashphoner.sendXcapRequest({url: Configuration.xcapUrl});
				if(app.flashphoner.mediaProvider && listeners.ready) listeners.ready();
				else if(!app.flashphoner.mediaProvider) console.log('MediaProvider not ready yet');
			break;
			default:
				if(SDK.debug)console.warn('Unknown registration status!')
		}
	});
	app.flashphoner.addListener(WCSEvent.OnCallEvent, function (event) {
		var call = event;
		if(SDK.debug)console.log("Phone - onCallListener " + call.callId + " call.mediaProvider: " + call.mediaProvider + " call.status: " + call.status);
		if (SDK.currentCall != null && !call.incoming) {
			SDK.holdedCall = SDK.currentCall;
			SDK.currentCall = call;
			if(SDK.debug)console.log("Phone - It seems like a hold: holdedCall: "+SDK.holdedCall.callId+" currentCall: "+SDK.currentCall.callId);
		} else {
			SDK.currentCall = call;
			if (call.incoming && listeners.incoming) listeners.incoming(call);
			else console.warn('Incoming call without listener!');
			if(SDK.debug)console.log("Phone - It seems like a new call currentCall: " +SDK.currentCall.callId + " status: " +SDK.currentCall.status);
		}
	});
	app.flashphoner.addListener(WCSEvent.CallStatusEvent, function (event) {
		var sipObject = event.sipMessageRaw;
		var call = event;
		if(SDK.debug)console.log(call,"Phone - callStatusListener call id: " + call.callId + " status: " + call.status + " mediaProvider: " + call.mediaProvider);
		if (SDK.currentCall.callId == call.callId) {
			SDK.currentCall.status = call.status;
			switch(call.status){
				case CallStatus.FINISH:
					if(SDK.debug)console.log("Phone - ... Call is finished...");
					if (SDK.holdedCall != null) {
						SDK.currentCall = SDK.holdedCall;
						SDK.holdedCall = null;
					} else if ( SDK.currentCall && SDK.currentCall.callId == call.callId ){
						SDK.currentCall = null;
						SoundControl.stopSound("RING");
						SoundControl.playSound("FINISH");
					}
					listeners.finish(call);
				break;
				case CallStatus.HOLD:
					if(SDK.debug)console.log('Phone - ...Call on hold...');
				break;
				case CallStatus.ESTABLISHED:
					if(SDK.debug)console.log('Phone - ...Talking...');
					SoundControl.stopSound("RING");
				break;
				case CallStatus.RING:
					if(SDK.debug)console.log('Phone - ...Ringing...');
					if(!Configuration.suppressRingOnActiveAudioStream)SoundControl.playSound("RING");
				break;
				case CallStatus.RING_MEDIA:
					if(SDK.debug)console.log('Phone - ...Ringing...');
					SoundControl.stopSound("RING");
				break;
				case CallStatus.BUSY:
					SoundControl.playSound("BUSY");
				break;
				case CallStatus.SESSION_PROGRESS:
					if(SDK.debug)console.log('Phone - ...Call in Progress...');
					SoundControl.stopSound("RING");
				break;
			}
		} else if (SDK.holdedCall.callId == call.callId && call.status == CallStatus.FINISH) {
			if(SDK.debug) console.log("It seems we received FINISH status on holdedCall. Just do null the holdedCall.");
			SDK.holdedCall = null;
		}
	});
	app.flashphoner.addListener(WCSEvent.OnMessageEvent, function (event) {
		var message = event;
		
		if (message.contentType == "application/im-iscomposing+xml" || message.contentType == "message/fsservice+xml") {
			console.log("ignore message: " + message.body);
			if (Configuration.disableUnknownMsgFiltering) {
				message.body = escapeXmlTags(message.body);
				SoundControl.playSound("MESSAGE");
			}
			return;
		}
		//convert body
		var body=message.body;
		//
		if(SDK.debug) console.log(body);
		var parser = new DOMParser();
		var xml = parser.parseFromString(body,"text/xml");
		//
		
		
		
		if (message.contentType == "application/fsservice+xml") {
			var xml = $.parseXML(body);
			var missedCallNotification;
			var fsService = $(xml).find("fs-services").find("fs-service");
			var action = fsService.attr("action");
			if (action == "servicenoti-indicate") {
				function parseMsn(fsService, mcn) {
					if(SDK.debug) console.log("Phone - parseMcn: " + mcn);
					var caw = fsService.find(mcn);
					var ret = null;
					if (!!caw) {
						var cawData = caw.find(mcn + "-data");
						if (!!cawData) {
							var sender = $(cawData).attr("sender");
							if (!!sender) {
								if(SDK.debug) console.log("Phone - Missed call: " + sender);
								ret = "Missed call from " + sender;
							}
						}
					}
					return ret;
				};
				var caw = parseMsn(fsService, "caw");
				missedCallNotification = (!!caw) ? caw : parseMsn(fsService, "mcn");
			} else if (action == "serviceinfo-confirm") {
				//service status confirmation
				missedCallNotification = "Service status: " + $(fsService.find("mcn").find("mcn-data")).attr("status");
			}
			if (missedCallNotification !== undefined){
				body=missedCallNotification;
			} 
		} else if (message.contentType == "application/vnd.oma.push") {
			var xml = $.parseXML(message.body);
			var content;
			if ($(xml).find("ums-service")) content = $(xml).find("ni-data").attr("content");
			body = content;
		}
		
		if(SDK.debug) console.log(body);
		
		if (body) {
			message.body = body;
			SoundControl.playSound("MESSAGE");
		} else {
			if(SDK.debug) console.log("Not displaying message " + message.body + ", body is null after convert");
			if (Configuration.disableUnknownMsgFiltering) {
				message.body = escapeXmlTags(message.body);
				SoundControl.playSound("MESSAGE");
			}
		}
		if(SDK.debug) console.log("Phone - onMessageListener id = " + message.id + " body = " + message.body);
		
	});
	app.flashphoner.addListener(WCSEvent.SubscriptionStatusEvent, function (event) {
		if (event.event == "reg" && event.terminate) app.phone.disconnect();
	});
	app.flashphoner.addListener(WCSEvent.XcapStatusEvent, function (xcapResponse) {
		if(SDK.debug) console.log("Phone - xcapStatusListener " + xcapResponse);
		var xml = $.parseXML(xcapResponse.responseBody);
		var history = $(xml).find("history-list").find("history");
		if (history != null && history.length != 0 && Configuration.msrpCallee != null && Configuration.msrpCallee.length != 0) app.phone.msrpCall(Configuration.msrpCallee);
	});
		
	app.flashphoner.addListener(WCSEvent.MessageStatusEvent, function (message) {
		console.log("Phone - messageStatusListener id = " + message.id + " status = " + message.status);
	});
	app.flashphoner.addListener(WCSEvent.RecordingStatusEvent, function (recordReport) {
		console.log("Phone - recordingStatusListener: " + recordReport.report.mixedFilename);
	});
	app.flashphoner.addListener(WCSEvent.BugReportStatusEvent, function (event) {
		console.log("Phone - bugReportStatusListener; filename - " + event.filename);
	});
	app.flashphoner.addListener(WCSEvent.OnTransferEvent, function (event) {
		console.log("Phone - onTransferEventListener status:" + event.status + " incoming:" + event.incoming);
	});
	app.flashphoner.addListener(WCSEvent.TransferStatusEvent, function (event) {
		console.log("Phone - onTransferStatusListener status:" + event.status + " incoming:" + event.incoming);
	});
	app.flashphoner.addListener(WCSEvent.OnDataEvent, function (event) {
		console.log("Phone - onDataEventListener; received data " + event.data);
	});
	app.flashphoner.addListener(WCSEvent.DataStatusEvent, function (event) {
		console.log("Phone - DataStatusEventListener; received status " + event.status);
	});
	
	
	//interface
	var listeners=[],wait_access_interval=-1,
	SDK = {
	        registered:false,//tgra: added status account autorization
		debug:true,
		holdedCall: null,
		currentCall: null,
		init:function(number,token,number2) {
			SDK.number=number;
			SDK.porta=number2;
			SDK.token=token;
			app.flashphoner.connect(number,token);
		},
		call:function(number, name, hasVideo, mediaProvider){
			hasVideo=hasVideo||false;
			mediaProvider=self.mediaProvider;
			if (!app.flashphoner.hasAccess(mediaProvider, hasVideo)) {
				if (wait_access_interval == -1) {
					wait_access_interval = setInterval(function () {
						if (app.flashphoner.hasAccess(mediaProvider, hasVideo)) {
							clearInterval(wait_access_interval);
							wait_access_interval = -1;
							SDK.call(number, hasVideo, mediaProvider);
						}
					}, 500);
				}
				app.flashphoner.getAccess(mediaProvider, hasVideo);
			} else if (app.flashphoner.hasAccess(mediaProvider, hasVideo)) {
				var call = {
					callId : "",
					status : "",
					caller : SDK.token,
					callee : number,
					incoming : false,
					visibleName : name || "Caller",
					inviteParameters : {
/*
						'x-apifo':SDK.token,
						'x-orgin':SDK.number,
						'x-term': number || "88009001000"
*/
					},
					mediaProvider : mediaProvider,
					hasVideo : hasVideo
				};
				this.currentCall = app.flashphoner.call(call);
			}else{
				if(SDK.debug) console.warn("Microphone is not plugged in");
				else listeners.error("Microphone is not plugged in");
			}
		},
		answer : function (call, hasVideo) {
			if(SDK.debug) console.log("Phone - answer " + call.callId);
			if (!app.flashphoner.hasAccess(call.mediaProvider, hasVideo)) {
				if (wait_access_interval == -1) {
					var checkAccessFunc = function () {
						if (app.flashphoner.hasAccess(call.mediaProvider, hasVideo)) {
							clearInterval(wait_access_interval);
							app.flashphoner.intervalId = -1;
							SDK.answer(call, hasVideo);
						}
					};
					wait_access_interval = setInterval(checkAccessFunc, 500);
				}
				app.flashphoner.getAccess(call.mediaProvider, hasVideo);
			} else if (app.flashphoner.hasAccess(call.mediaProvider, hasVideo)) {
				call.hasVideo = hasVideo;
				app.flashphoner.answer(call);
			} else {
				if(SDK.debug) console.log("Microphone is not plugged in");
				listeners.error("Microphone is not plugged in");
			}
		},
		cancel:function () {
			if (this.currentCall) this.hangup(this.currentCall);
		},
		mute:function(mute){
			app.flashphoner[mute?'mute':'unmute']();
		},
		sendDTMF : app.flashphoner.sendDTMF,//({callId: callId, dtmf: dtmf})
		hangup : app.flashphoner.hangup,
		hold : app.flashphoner.hold,
		unhold : app.flashphoner.unhold,
		transfer : app.flashphoner.transfer,//({callId: callId, target: target})
		disconnect: function(){
			console.warn('Apifonica disonnected');
			app.flashphoner.disconnect();
		}
	}
	if(SDK.debug)SDK.backdoor=app;
	Object.defineProperty(SDK, "onerror", {
		get: function() {
			return "(setter of [error handlers])";
		},
		set: function(listener) {
			listeners.error=listener;
		}
	});
	Object.defineProperty(SDK, "incoming", {
		get: function() {
			return "(setter of [error handlers])";
		},
		set: function(listener) {
			listeners.incoming=listener;
		}
	});
	Object.defineProperty(SDK, "onready", {
		get: function() {
			return "(setter of [error handlers])";
		},
		set: function(listener) {
			listeners.ready=listener;
		}
	});	
	Object.defineProperty(SDK, "onfinish", {
		get: function() {
			return "(setter of [error handlers])";
		},
		set: function(listener) {
			listeners.finish=listener;
		}
	});	
	return SDK;
}


if (window.addEventListener)  // W3C DOM
	window.addEventListener("load",function(){
		window.Apifo=new _Apifo();
	},false);
else if (window.attachEvent) { // IE DOM
	window.attachEvent("onload", function(){
		window.Apifo=new _Apifo();
	});
}else alert('You browser not supported by Apifonica webSDK.');