Apifonica WebPhone (WebRTC) Example
===================================

This is a very simple demo showing how you can make phone calls using WebRTC service from the web browser to both sip addresses and PSTN phone numbers.
There is a live webphone demo (http://localhost:8000/). 
The entire source code is available in `/public` folder.

### Where it All Begins
In the document's ready function is where the Apifonica JS Object is initialised
	```
    $(document).ready(function() {
		Apifo.onerror=function(error){
			ui.error(error);
			ui.ready_to_call();
		}
		Apifo.onready = onReady;
		Apifo.onfinish = ui.ready_to_call;
		Apifo.incoming = onIncoming;
		Apifo.init(number.number, number.password);
    });
	```

### Registering
The UI starts off with a basic login screen that accepts your credentials. To enter the username and password values for login, use the following code:
	```
    function login() {
		Apifo.init(number.number, number.password);
    }
	```

The onReady listener function, which was registered at the start, is invoked when Apifonica sends back the onReady event:
	```
    function onReady() {
		ui.ready_to_call();
		ui.bind_call_events();
    }
	```

### Making a Call
Enter the number in the post-login UI and click the "Call" button. This action causes the following code to run:
	```
    call_button.onclick=function(){
		var number=document.getElementById('call_to').value
		if(!/\+?[\d]{10,15}/.test(number)){
			ui.error('Not correct number');
		}else{
			ui.start_counter();
			Apifo.call(number);
		}		
	}
	```

After discarding validations and UI state changes, the code boils down to one line:
	```
    Apifo.call(number);
	```

### Handling Incoming Calls
By creating the onIncoming call listener, the Apifonica JS object can handle calls coming into the Apifonica number.
	```
    function onIncoming(call) {
		console.log('Incoming call from', call.caller);
		answer_button.onclick = function(){
			Apifo.answer();
			ui.start_counter();
		};
		hangup_button.onclick = function(){
			Apifo.cancel();
			ui.stop_counter();
		}
	}
	```

The two actions that can be performed then are answer and reject.  

### Terminating a Call
This code may be used to terminate a call. 
	```
    Apifo.cancel();
	```
