﻿var express = require('express'),
    router = express.Router(),
    passport = require('passport'),
    http = require('http'),
    https = require('https'),
    fs = require('fs'),
    jwt = require('jwt-simple'),
    AWS = require('aws-sdk'),
    crypto = require('crypto'),
    async = require('async'),
    Strategy = require('passport-local').Strategy;

router.use(passport.initialize());
router.use(passport.session());
passport.use(new Strategy({
    usernameField: 'login',
    passwordField: 'pass'
}, function (username, password, done) {
    //console.log(username, password);
    engine.db.get_user_by_login(username, function (err, user) {
        if (err) {
            console.error(err.message);
            return done(err);
        }
        //console.log(err,user);
        if (!user)return done('Not found');
        if (user.pass == password) {
            return done(null, user);
        } else {
            return done('incorrect pass');
        }
    });
}));
passport.serializeUser(function (user, done) {
    //console.log('serialize',user);
    if (user) done(null, user.id);
    else done();
});
passport.deserializeUser(function (id, done) {
    //console.log('deserialize');
    engine.db.get_user_by_id(id, function (err, user) {
        if (err) {
            console.error(err.message);
            return done(err);
        }
        //console.log(err,user);
        if (!user)return done('Not found');
        return done(null, user);
    });
});

module.exports = function (engine) {
    router.get('/send_push', function (req, res) {
        AWS.config.update(config.amazon);
        var payload = {
            GSM: {
                title: "Knock Knock Callout",
                color: "#009911",
                sound: "default",
                data: {
                    message: "Incoming call from " + num,
                    number: num,
                    call_sid: 'CAG34BCVBOO875555PQ2N4'
                }
            },
            "default": "Default message",
            APNS_SANDBOX: JSON.stringify({
                "aps": {
                    "alert": "Incoming call from " + req.body.from,
                    "payload": {
                        "number": req.body.from,
                        "call_sid": req.body.call_sid
                    },
                    "sound": "default"
                }
            })
        };
        var sns = new AWS.SNS();
        sns.publish({
            TargetArn: push_data.arn,
            Message: JSON.stringify(payload),
            MessageStructure: 'json'
        }, function (err, data) {
            if (err) {
                console.error("Error sending a message ", err);
                res.status(500).end(err);
            } else {
                console.log("Sent message: ", data);


                var now = new Date();
                var log2 = now.getHours() + ':' + now.getMinutes() + ':' + now.getSeconds() + '.' + now.getMilliseconds() + ' R AWS SNS > Service\r\n';
                log2 += '               ' + JSON.stringify(data);
                engine.socket.server.emit('e', {
                    type: '/push_succes',
                    log: log2
                });

                next();
            }
        });
    });

    router.get('/', function (req, res) {
        res.render('callout', {authenticated_user: req.isAuthenticated() ? req.user.login : null});
    });
    router.get('/register', function (req, res) {
        engine.db.get_all_numbers({}, (err, numbers) => {
            engine.db.get_all_users({}, (err, users) => {
                console.log(err || users);
                res.render('register', {
                    sid: config.apifo.sid,
                    token: config.apifo.token,
                    numbers: numbers,
                    users: users
                });
            })
        })
    });
    router.post('/register', function (req, res) {
        if (!req.body.login || !req.body.password || !req.body.app_id) res.status(400).end('login password app_id required');
        else engine.db.add_user(req.body, (err, resp) => {
            if (err) res.status(400).end(JSON.stringify(err));
            else res.end('Your account is registered');
        });
    });
    router.get('/old_webphone', function (req, res) {
        //console.log('User identity:',req.isAuthenticated(),req.user);
        res.render('index', {
            logged: req.isAuthenticated(),
            username: req.user ? req.user.login : null,
            title: 'Apifonica old webphone'
        });
    });
    router.get('/front_client', function (req, res) {
        res.render('front_client', {title: 'Apifonica Ajax lib demo'});
    });
    router.get('/log', function (req, res) {
        res.render('nice_log');
    });
    router.all('/xml/*', require('./xml.js')(engine));
    router.get('/sync', (req, res) => {
        engine.sync();
        res.end('Sync started..');
    });
    router.get('/test', (req, res) => {


    });


    router.get('/generate_token', function (req, res) {
        console.log('Test proxy');
        var number = {
            login: "1234567890",
            password: ''
        }
        console.log(req.user);
        var payload = {
            account_sid: req.user.id,
            number_sid: number.login,
            app_sid: req.user.app_id,
            expired: (Date.now() + config.token_expire),
            outbound: true,
            inbound: true
        };
        //var token = jwt.encode(payload, secret);
        var token = jwt.encode(payload, config.secret);
        console.log(token);
        res.end(JSON.stringify({
            number: number.login,
            password: token,
            expire: (Date.now() + config.token_expire) / 1000,
            user_id: req.user.id
        }));
    });


    /**
     @api {post} login login
     @apiName login
     @apiGroup Auth
     @apiVersion 0.0.1

     @apiParam {string} login - login
     @apiParam {string} pass - password
     */
    router.post('/login', function (req, res, next) {
        //console.log(req.sessionID);
        passport.authenticate('local', function (err, user) {
            //console.log(err,user);
            req.login(user, function (err) {
                if (err) {
                    console.error(err, req.body, req.headers);
                    res.status(401).end('Bad credentials');
                } else if (req.headers['x_requested_with'] || req.headers['x-requested-with']) {
                    res.end(err ? JSON.stringify(err) : '{"status":200,"message":"OK"}');
                } else {
                    res.redirect('/');
                }
            });
        })(req, res, next);
    });
    /**
     @api {post} oauth2/auth/login login
     @apiName /oauth2/auth/login
     @apiGroup Mirror
     @apiVersion 0.0.1

     @apiParam {string} client_id - login
     @apiParam {string} client_secret - password

     @apiSuccess {json} data
     @apiSuccessExample {json} data:
     { "access_token" = cecf8cf106c8a85c9bbc757869d5bd05107e3260; "expire" = 86400; id = 457b55bb8d06d720f596a07a4935421b; message = OK; scope = "<null>"; status = 200; "token_type" = Bearer; type = client; }
     */
    router.post('/oauth2/auth/login', function (req, res, next) {
        //console.log(req.sessionID);
        req.body.login = req.body.client_id;
        req.body.pass = req.body.client_secret;
        passport.authenticate('local', function (err, user) {
            //console.log(err,user);
            req.login(user, function (err) {
                if (err) {
                    console.error(err, req.body, req.headers);
                    res.status(401).end('Bad credentials');
                } else {
                    var connectsid = 's%3A' + encodeURIComponent(req.sessionID + '.' + crypto.createHmac('sha256', config.secret).update(req.sessionID).digest('base64').replace(/\=+$/, ''));
                    res.json({
                        access_token: connectsid,
                        expire: (Date.now() + req.session.cookie.maxAge) / 1000,
                        message: "OK",
                        id: req.body.login,
                        status: 200,
                        scope: "<null>",
                        token_type: "Bearer",
                        type: "client"
                    })
                }
            });
        })(req, res, next);
    });

    /**
     @api {post} logout logout
     @apiName logout
     @apiGroup Auth
     @apiVersion 0.0.1

     */
    router.post('/logout', function (req, res) {
        req.logout();
        if (req.headers['x_requested_with'] || req.headers['x-requested-with']) {
            res.end('{"status":200,"message":"OK"}');
        } else {
            res.redirect('/');
        }
    });
    /**
     @api {post} oauth2/auth/logout logout
     @apiName /oauth2/auth/logout
     @apiGroup Mirror
     @apiVersion 0.0.1

     */
    router.post('/oauth2/auth/logout', function (req, res) {
        req.logout();
        res.end('{"status":200,"message":"OK"}');
    });


    router.post('/register', function (req, res) {

    });

    router.use('/api_proxy/*', function (in_req, in_res) {
        console.log('REQ BODY: ', in_req.body);
        console.log('REQ HEADERS: ', in_req.headers);
        var data = typeof in_req.body == 'string' ? in_req.body : JSON.stringify(in_req.body);
        var query = in_req.query;
        var headers = {};
        ['content-type', 'cookie'].map(function (item) {
            if (in_req.headers[item]) headers[item] = in_req.headers[item];
        })
        var options = {
            hostname: "api.apifonica.com",
            port: 443,
            path: in_req.originalUrl.split('/api_proxy')[1],
            method: in_req.method,
            headers: headers
        };
        console.log(data, options)
        var req = https.request(options, function (res) {
            console.log('RES STATUS: ' + res.statusCode);
            console.log('RES HEADERS: ' + JSON.stringify(res.headers));
            console.log('RES BODY: ' + JSON.stringify(res.headers));
            var resp = '';
            res.on('data', function (chunk) {
                resp += chunk;
            });
            res.on('end', function () {
                //BAD.
                var log = 'Time: ' + new Date().toUTCString() + '\r\nRequest: ' + JSON.stringify(options) + '\r\nRequest data: ' + JSON.stringify(data) + '\r\nResponse: ' + resp + '\r\n\r\n';
                fs.appendFile('./proxy_log.log', log);
                in_res.status(res.statusCode);
                in_res.end(resp);
            })
        });
        req.on('error', function (e) {
            console.log('problem with request: ', e);
            in_res.status(500);
            in_res.end(JSON.stringify(e));
        });
        req.write(data);
        req.end();
    });

    router.use('/*', function (req, res, next) {
        if (!req.isAuthenticated()) {
            console.log(new Date(), req.user, req.body, req.headers);
            res.sendStatus(401).end('Unauthorized');
        } else next();
    });
    router.get('/proxy_log', function (req, res) {
        res.end(fs.readFileSync('./proxy_log.log'));
    });


    /**
     @api {post} my_numbers Numbers rented
     @apiName my_numbers
     @apiGroup Apifonica Example
     @apiVersion 0.0.0

     @apiSuccess {json} numbers
     @apiSuccessExample {json} numbers:
     [
     {"number":"your number", "password": "password", "number_sid":"numberSid", "token":"number_token", "expire": "token expiration timestamp (unix time)" },
     {"number":"your number", "password": "password", "number_sid":"numberSid", "token":"number_token", "expire": "token expiration timestamp (unix time)" }
     ]
     */
    router.post('/my_numbers', function (req, res) {
        engine.db.get_my_numbers(req.user.id, function (err, numbers) {
            for (var i in numbers) {
                numbers[i].expire = (Date.now() + config.token_expire) / 1000;
            }
            res.json(numbers);
        });
    });
    /**
     @api {post} v2/apps/:app_id/my_numbers Numbers rented
     @apiName my_numbers
     @apiGroup Mirror
     @apiVersion 0.0.0

     @apiParam {String} app_id - app id (clients shouldnt know this)
     @apiParam {String} token - auth token

     @apiSuccess {json} numbers
     @apiSuccessExample {json} numbers:
     [
     {"number":"your number", "password": "jwt token", "number_sid":"numberSid", "token":"number_token", "expire": "token expiration timestamp (unix time)" },
     {"number":"your number", "password": "jwt token", "number_sid":"numberSid", "token":"number_token", "expire": "token expiration timestamp (unix time)" }
     ]
     */
    router.post('/v2/apps/:app_id/my_numbers', function (req, res) {
        engine.db.get_my_numbers(req.user.id, function (err, numbers) {
            for (var i in numbers) {
                numbers[i].expire = (Date.now() + config.token_expire) / 1000;
            }
            res.json({numbers: numbers});
        });
    });


    /**
     @api {get} /v2/availableCountries Available Countries
     @apiName available_countries
     @apiGroup Apifonica Example
     @apiVersion 0.0.0

     @apiSuccess {json} Array of countries objects
     */
    router.get('/v2/availableCountries', function (req, res) {
        engine.Apifo2.get_available_countries({}, function (err, resp) {
            console.log(err || resp);
            if (err) {
                if (err.statusCode) res.status(err.statusCode);
                res.end(JSON.stringify(err));
            }
            else res.end(JSON.stringify(resp));
        });
    });
    /**
     @api {post} available_numbers Available numbers
     @apiName available_numbers
     @apiGroup Apifonica Example
     @apiVersion 0.0.0

     @apiParam {string} [type=SIP] - The type of returning phone numbers. This parameter can either be NATIONAL or SIP.
     @apiParam {string} country_code - Required for NATIONAL type only. The region name for the specified type of phone numbers. US—United States, DE—Germany, FR—France, CA—Canada, FI—Finland, AT—Austria, CH—Switzerland, PL—Poland, SE—Sweden, IT—Italy, LU—Luxemburg, ES—Spain, MX—Mexico, PT—Portugal, IL—Israel, CZ—Czech Republic, DK—Denmark.
     @apiParam {number} [limit=1] - limit

     @apiSuccess {json} Array of number objects
     */
    router.post('/available_numbers', function (req, res) {
        var input = {};
        if (req.body.type) input.type = req.body.type;
        if (req.body.limit) input.limit = req.body.limit;
        console.log(input, req.body);
        if (!req.body.type || req.body.type == "SIP") {
            console.log('#Try to get available sip numbers');
            engine.Apifo2.get_available_sip_numbers(input, function (err, resp) {
                console.log(err || resp);
                if (err) {
                    if (err.statusCode) res.status(err.statusCode);
                    res.end(JSON.stringify(err));
                }
                else res.end(JSON.stringify(resp));
            });
        } else {
            if (req.body.country_code) input.country_code = req.body.country_code;
            else if (req.body.location) input.country_code = req.body.location;
            else {
                res.status(400).end('{"status":"400","error":"country_code required"}');
                return;
            }
	    console.log('#Try to get available numbers');
            engine.Apifo2.get_available_numbers(input, function (err, resp) {
                console.log(err || resp);
                if (err) {
                    if (err.statusCode) res.status(err.statusCode);
                    res.end(JSON.stringify(err));
                }
                else res.end(JSON.stringify(resp));
            });
        }

    });
    /**
     @api {post} v1/numbers Available numbers
     @apiName available_numbers
     @apiGroup Mirror
     @apiVersion 0.0.0


     @apiParam {string} [type=SIP] - The type of returning phone numbers. This parameter can either be NATIONAL or SIP.
     @apiParam {string} country_code - Required for NATIONAL type only. The region name for the specified type of phone numbers. US—United States, DE—Germany, FR—France, CA—Canada, FI—Finland, AT—Austria, CH—Switzerland, PL—Poland, SE—Sweden, IT—Italy, LU—Luxemburg, ES—Spain, MX—Mexico, PT—Portugal, IL—Israel, CZ—Czech Republic, DK—Denmark.
     @apiParam {number} [limit=1] - limit

     @apiSuccess {json} Array of number objects
     */
    router.post('/v2/numbers', function (req, res) {
        var input = {};
        if (req.body.type) input.type = req.body.type;
        if (req.body.limit) input.limit = req.body.limit;
        console.log(input, req.body);
        if (!req.body.type || req.body.type == "SIP") {
            console.log('##Try to get available sip numbers');
            engine.Apifo2.get_available_sip_numbers(input, function (err, resp) {
                console.log(err || resp);
                if (err) {
                    if (err.statusCode) res.status(err.statusCode);
                    res.end(JSON.stringify({error: [err]}));
                }
                else res.end(JSON.stringify(resp));
            });
        } else {
            if (req.body.country_code) input.country_code = req.body.country_code;
            else if (req.body.location) input.country_code = req.body.location;
            else {
                res.status(400).end('{"status":"400","error":"country_code required"}');
                return;
            }
	    console.log('##Try to get available numbers');
            engine.Apifo2.get_available_numbers(input, function (err, resp) {
                console.log(err || resp);
                if (err) {
                    if (err.statusCode) res.status(err.statusCode);
                    res.end(JSON.stringify({error: [err]}));
                }
                else res.end(JSON.stringify(resp));
            });
        }
    });


    /**
     @api {post} rent_number Rent number
     @apiName rent_number
     @apiGroup Apifonica Example
     @apiVersion 0.0.0

     @apiParam {String} number - Phone number to rent

     @apiSuccess {json} Number object
     {"number":"your number", "password": "jwt token", "expire": "token expiration timestamp (unix time)", "user_id": "user id" }
     */
    router.post('/rent_number', function (req, res) {
        console.log('#Try to rent', req.body.number, req.body.user);
        var input = {
	    number: req.body.number,
            call_app_sid: req.user.app_id,
            msg_app_sid: req.user.app_id 
        };
        if (req.body.type) input.type = req.body.type;
        engine.Apifo2.rent_number(input, function (err, number) {
            if (err) {
                console.error(err || number);
                res.status(err.status_code || 500);
                res.end(JSON.stringify(err));
            } else {
                var number_sid = number.uri.split('/')[5];
                console.log(number_sid);
                engine.Apifo2.get_number({
                    number_sid
                }, (err, number) => {
                    console.log(number);
                    var pass = engine.generate_pass();
		    console.log('#Try to update number', req.body.number);
                    engine.Apifo2.update_number({
                        number_sid,
		       // call_app_sid: req.user.app_id,
			mode: "sip_phone", // "xml",
                        sip_password: pass
                    }, (err, resp) => {
                        if (err) throw err;
                        engine.db.save_number({
			    token: number.token,
                            number_sid,
                            number: number.number,
                            password: pass,
                            user_id: req.user.id
                        }, function (err, resp) {
                            res.end(JSON.stringify({
                                number: number.number,
                                password: pass,
                                expire: (Date.now() + config.token_expire) / 1000,
				number_sid: number_sid,
				token: number.token,
                                user_id: req.user.id
                            }));
                        });
                    });
                });
            }
        });
    });
    /**
     @api {post} v1/apps/:app_id/numbers Rent number
     @apiName rent_number
     @apiGroup Mirror
     @apiVersion 0.0.0

     @apiParam {String} number - Phone number to rent
     @apiParam {String} token - auth token
     @apiParam {String} app_id - app id (clients shouldnt know this)

     @apiSuccess {json} Number object
     @apiSuccessExample {json} number:
     {"number":"your number", "password": "jwt token", "expire": "token expiration timestamp (unix time)", "user_id": "user id" }
     */
    router.post('/v2/apps/:app_id/numbers', function (req, res) {
        console.log('##Try to rent', req.body.number);
        var input = {
	    number: req.body.number,
            call_app_sid: req.user.app_id,
            msg_app_sid: req.user.app_id
        };
        //if(req.body.type)input.type=req.body.type;
        engine.Apifo2.rent_number(input, function (err, number) {
            if (err) {
                console.error(err);
                res.status(400);
                res.end(JSON.stringify(err));
            } else {
                var number_sid = number.uri.split('/')[5];
                console.log('Success rented', number_sid);
                engine.Apifo2.get_number({
                    number_sid
                }, (err, number) => {
	            console.log('##Try to update number', req.body.number);
                    var pass = engine.generate_pass();
                    engine.Apifo2.update_number({
                        number_sid,
		       // call_app_sid: req.user.app_id,
			mode: "sip_phone", // "xml",
                        sip_password: pass
                    }, (err, resp) => {
                        if (err) {
                            console.error(err);
                            res.status(400);
                            res.end(JSON.stringify(err));
                        } else engine.db.save_number({
			    token: number.token,
                            number_sid: number_sid,
                            number: number.number,
                            password: pass,
                            user_id: req.user.id
                        }, function (err, resp) {
                            res.end(JSON.stringify({
                                number: number.number,
                                password: pass,
                                expire: (Date.now() + config.token_expire) / 1000,
				number_sid: number_sid,
				token: number.token,
                                user_id: req.user.id
                            }));
                        });
                    });
                });
            }
        });
    });


    /**
     @api {post} number_info Number info
     @apiName number_info
     @apiGroup Apifonica Example
     @apiVersion 0.0.0

     @apiParam {String} number - Phone number to rent

     @apiSuccess {json} Number object
     */
    router.post('/number_info', function (req, res) {
        engine.db.get_number(req.body.number, (err, number) => {
            if (err) {
                console.error(err);
                res.statusCode(500).end(err.toString());
                return;
            }

            var payload = {
                exp: (Date.now() + config.token_expire) / 1000,
                inc: 1,
                out: req.user.app_id
                //account_sid:req.user.id,
                //sip_password:number.number,
                //sip_login:number.number,
                //lifespan:(Date.now()+config.token_expire)/1000,
                //outbound:true,
                //inbound:true
            };
            var token = jwt.encode(payload, config.secret);
            /*
             if (number.password.split('.').length == 3) {
             var t = jwt.decode(number.password, config.secret);
             if(t.sip_password) number.password = t.sip_password;
             }
             */
            number.expire = (Date.now() + config.token_expire) / 1000;
            number.password = token;
            res.json(number);
        });
    });
    /**
     @api {get} v1/apps/:app_id/numbers/:number Number info
     @apiName number_info
     @apiGroup Mirror
     @apiVersion 0.0.0

     @apiParam {String} number - Phone number to rent
     @apiParam {String} token - auth token
     @apiParam {String} app_id - app id (clients shouldnt know this)

     @apiSuccess {json} Number object
     */
    router.get('/v2/apps/:app_id/numbers/:number', function (req, res) {
        engine.db.get_number(req.params.number, (err, number) => {
            if (err) {
                console.error(err);
                res.status(500).end(err.toString());
                return;
            }
            console.log(number);
            /*
             var payload = {
             exp:(Date.now()+config.token_expire)/1000,
             inc: 1,
             out: req.user.app_id
             //account_sid:req.user.id,
             //sip_password:number.number,
             //sip_login:number.number,
             //lifespan:(Date.now()+config.token_expire)/1000,
             //outbound:true,
             //inbound:true
             };
             var token = jwt.encode(payload,config.secret);
             */
            /*
             if (number.password.split('.').length == 3) {
             var t = jwt.decode(number.password, config.secret);
             if(t.sip_password) number.password = t.sip_password;
             }
             */
            //number.password = pass;
            number.expire = (Date.now() + config.token_expire) / 1000;
            res.json(number);
        });
    });


    /**
     @api {post} update_pass Update password
     @apiName update_pass
     @apiGroup Apifonica Example
     @apiVersion 0.0.0

     @apiParam {String} number - Phone number
     @apiParam {String} [password=auto generated] - new password
     @apiParam {String} [length=11] - length of generated password

     @apiSuccess {json} Number object
     {"number":"your number", "password": "jwt token", "expire": "token expiration timestamp (unix time)", "user_id": "user id" }
     */
    router.post('/update_pass', function (req, res) {
        //The password must contain at least 10 and no more than 16 characters and consist of letters and numbers.
        var token, password = req.body.password || (length => {
                if (!length || length <= 0) length = 11;
                var text = "", alph = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_";
                while (text.length < length - 1)text += alph.charAt(Math.floor(Math.random() * alph.length));
                text += alph.charAt(Math.floor(Math.random() * 10)); //and one digit.
                return text;
            })(req.body.length);
        console.log(req.body.number, password);
	console.log('#Try to update number async.waterfall', req.body.number);
        async.waterfall([
            next => engine.db.get_number(req.body.number, next),
            (number, next) => engine.Apifo2.update_number({
                number: req.body.number,
                app_id: req.user.app_id,
                password: password
            }, next),
            (result, next) => {
                token = jwt.encode({
                    account_sid: req.user.id,
                    sip_password: password,
                    sip_login: req.body.number,
                    app_sid: req.user.app_id,
                    lifespan: (Date.now() + config.token_expire) / 1000,
                    outbound: true,
                    inbound: true
                }, config.secret);
                next(null, token);
            },
            (token, next) => engine.db.update_number({
                number: req.body.number,
                password: token,
                user_id: req.user.id
            }, next)
        ], function (err, r) {
            if (err) {
                console.error(err);
                if (err.validate_result && err.validate_result.password) res.status(400).end('The password must contain at least 10 and no more than 16 characters and consist of letters and numbers.');
                else res.status(err.status || 400).end(err.toString());
            } else res.json({
                number: req.body.number,
                password: token,
                expire: (Date.now() + config.token_expire) / 1000,
                user_id: req.user.id
            });
        });
    });
    /**
     @api {post} v1/apps/:app_id/numbers/:number Update password
     @apiName update_pass
     @apiGroup Mirror
     @apiVersion 0.0.0

     @apiParam {String} number - Phone number
     @apiParam {String} app_id - app id
     @apiParam {String} token - auth token
     @apiParam {String} [password=auto generated] - new password
     @apiParam {String} [length=11] - length of generated password

     @apiSuccess {json} Number object
     @apiSuccessExample {json} number:
     {"number":"your number", "password": "jwt token", "expire": "token expiration timestamp (unix time)", "user_id": "user id" }
     */
    router.post('/v2/apps/:app_id/numbers/:number', function (req, res) {
        //The password must contain at least 10 and no more than 16 characters and consist of letters and numbers.
        var token, password = req.body.password || (length => {
                if (!length || length <= 0) length = 11;
                var text = "", alph = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_";
                while (text.length < length - 1)text += alph.charAt(Math.floor(Math.random() * alph.length));
                text += alph.charAt(Math.floor(Math.random() * 10)); //and one digit.
                return text;
            })(req.body.length);
        console.log(req.params.number, password);
	console.log('##Try to update number async.waterfall', req.params.number);
        async.waterfall([
            next => engine.db.get_number(req.params.number, next),
            (number, next) => engine.Apifo2.update_number({
                number: req.params.number,
                app_id: req.user.app_id,
                password: password
            }, next),
            (result, next) => {
                token = jwt.encode({
                    account_sid: req.user.id,
                    sip_password: password,
                    sip_login: req.params.number,
                    app_sid: req.user.app_id,
                    lifespan: (Date.now() + config.token_expire) / 1000,
                    outbound: true,
                    inbound: true
                }, config.secret);
                next(null, token);
            },
            (token, next) => engine.db.update_number({
                number: req.params.number,
                password: token,
                user_id: req.user.id
            }, next)
        ], function (err, r) {
            if (err) {
                console.error(err);
                if (err.validate_result && err.validate_result.password) res.status(400).end('The password must contain at least 10 and no more than 16 characters and consist of letters and numbers.');
                else res.status(err.status || 400).end(err.toString());
            } else res.json({
                number: req.params.number,
                password: token,
                expire: (Date.now() + config.token_expire) / 1000,
                user_id: req.user.id
            });
        });
    });


    /**
     @api {post} release_number Release number
     @apiName release_number
     @apiGroup Apifonica Example
     @apiVersion 0.0.0

     @apiParam {String} number - Phone number to release

     @apiSuccess {json} Number object
     */
    router.post('/release_number', function (req, res) {
        engine.db.get_number(req.body.number, (err, number) => {
            engine.Apifo2.delete_number({
                number_sid: number.number_sid
            }, function (err, result) {
                if (err) {
                    console.error(err);
                    res.status(err.status_code);
                    res.end(JSON.stringify(err));
                } else engine.db.delete_number({
                    number: req.body.number,
                    user_id: req.user.id
                }, function (err, resp) {
                    if (err) console.error(err);
                    res.end(JSON.stringify(result || err));
                });
            });
        });
    });
    /**
     @api {delete} v2/apps/:app_id/numbers/:number Release number
     @apiName release_number
     @apiGroup Mirror
     @apiVersion 0.0.0

     @apiParam {String} number - Phone number to release
     @apiParam {String} app_id - app id (clients shouldnt know this)
     @apiParam {String} token - auth token

     @apiSuccess {json} Number object
     */
    router.delete('/v2/apps/:app_id/numbers/:number', function (req, res) {
        engine.db.get_number(req.params.number, (err, number) => {
            if (err || !number || !number.number_sid) {
                console.log(err, number);
                res.status(404).end('Number not found');
            } else {
                engine.Apifo2.delete_number({
                    number_sid: number.number_sid
                }, function (err, result) {
                    if (err) {
                        console.error(err);
                        res.status(err.status_code);
                        res.end(JSON.stringify(err));
                    } else engine.db.delete_number({
                        number: req.params.number,
                        user_id: req.user.id
                    }, function (err, resp) {
                        if (err) console.error(err);
                        res.end(JSON.stringify(result || err));
                    });
                });
            }
        });
    });


    /**
     @api {post} v2/apps/:app_id/numbers/:number/jwt_token Get JWT-token
     @apiName jwt_token
     @apiGroup Apifonica Example
     @apiVersion 0.0.0

     @apiSuccess json response
     @apiSuccess object.status 200
     @apiSuccess object.message Ok
     @apiSuccess object.jwttoken JWT-token
     @apiSuccess object.expire expire
     */
    router.get('/v2/apps/:app_id/numbers/:number/jwt_token', function (req, res) {
        var payload = {
            exp: Math.floor((Date.now() + config.token_expire) / 1000),
            out: req.user.app_id,
            inp: 1
        };
        var token = jwt.encode(payload, config.secret);
        res.end(JSON.stringify({
            status: 200,
            message: "Ok",
            jwttoken: token,
            expire: Math.floor((Date.now() + config.token_expire) / 1000)
        }));
    });
    /**
     @api {post} jwt_token Get JWT-token
     @apiName jwt_token
     @apiGroup Apifonica Example
     @apiVersion 0.0.0

     @apiSuccess json response
     @apiSuccess object.status 200
     @apiSuccess object.message Ok
     @apiSuccess object.jwttoken JWT-token
     @apiSuccess object.expire expire
     */
    router.get('/jwt_token', function (req, res) {
        var payload = {
            exp: Math.floor((Date.now() + config.token_expire) / 1000),
            out: req.user.app_id,
            inp: 1
        };
        var token = jwt.encode(payload, config.secret);
        res.end(JSON.stringify({
            status: 200,
            message: "Ok",
            jwttoken: token,
            expire: Math.floor((Date.now() + config.token_expire) / 1000)
        }));
    });

    /**
     @api {post} push_id Set push identificator

     @apiName push_id
     @apiGroup Apifonica Example
     @apiVersion 0.0.0

     @apiParam {String} number - Phone number
     @apiParam {String} push_id - new password
     @apiParam {String} type -  ios | android | winmobile

     @apiSuccess json response
     @apiSuccess object.status 200
     @apiSuccess object.message Ok
     */
    router.post('/push_id', function (req, res) {
        var now = new Date();
        var log2 = now.getHours() + ':' + now.getMinutes() + ':' + now.getSeconds() + '.' + now.getMilliseconds() + ' R Phone > Service ' + req.method + ' ' + req.originalUrl + '\r\n';
        log2 += '               ' + JSON.stringify(req.body);
        engine.socket.server.emit('e', {
            type: '/push_id',
            log: log2
        });


        async.waterfall([
            next => engine.db.get_number(req.body.number, next),
            (number, next) => {
                AWS.config.update(config.amazon);
                var sns = new AWS.SNS();
                var android = false;
//                if( (/^[0-9a-fA-F]{64}$/).test(req.body.push_id) )
                var params = {
                    PlatformApplicationArn: config.amazon.app_arn_apple,
                    Token: req.body.push_id
                };
//                else{
//                    var params = {
//                        PlatformApplicationArn:config.amazon.app_arn_android,
//                        Token:req.body.push_id
//                    };
//                    android = true;
//                }
                sns.createPlatformEndpoint(params, function (err, EndPointResult) {
                    if (err) console.error(err);
                    var push_id = {};
                    try {
                        push_id = JSON.parse(number.push_id) || {};
                    } catch (e) {
                        console.error(e);
                    }
                    if (EndPointResult) {
                        if (android) push_id.arn_android = EndPointResult["EndpointArn"];
                        else push_id.arn = EndPointResult["EndpointArn"];
                    }
                    next(null, JSON.stringify(push_id));
                });
            },
            (push_json_string, next) => engine.db.update_number({
                number: req.body.number,
                push_id: push_json_string,
                user_id: req.user.id
            }, next)
        ], function (err, r) {
            if (err) {
                console.error(err);
                res.status(err.status || 400).end(err.toString());
            } else res.json({
                status: 200,
                message: "Ok"
            });

            var now = new Date();
            var log2 = now.getHours() + ':' + now.getMinutes() + ':' + now.getSeconds() + '.' + now.getMilliseconds() + ' Service > Phone ' + res.statusCode + ' ' + res.statusMessage + '\r\n';
            log2 += '               Ok';
            engine.socket.server.emit('e', {
                type: 'data',
                log: log2
            });
        });
    });


    /**
     @api {post} push_invite Push catched

     @apiName push_invite
     @apiGroup Apifonica Example
     @apiVersion 0.0.0

     @apiParam {String} number - Phone number
     @apiParam {String} call_sid - Call sid

     @apiSuccess json response
     @apiSuccess object.status 200
     @apiSuccess object.message Ok
     */
    router.post('/push_invite', function (req, res) {
        var now = new Date();
        var log2 = now.getHours() + ':' + now.getMinutes() + ':' + now.getSeconds() + '.' + now.getMilliseconds() + ' R Phone > Service ' + req.method + ' ' + req.originalUrl + '\r\n';
        log2 += '               ' + JSON.stringify(req.body);
        engine.socket.server.emit('e', {
            type: '/push_invite',
            log: log2
        });

        var data = req.body;
        data.controller = config.domain + "/xml/makeCall";

        try {
            var now = new Date();
            var log2 = now.getHours() + ':' + now.getMinutes() + ':' + now.getSeconds() + '.' + now.getMilliseconds() + ' R Service > MTT POST https://api.apifonica.com/api/v2/accounts/7c7b25bde7b455eba6b1784297cd521c/calls/' + req.body.call_sid + '\r\n';
            log2 += '               ' + JSON.stringify(data);
            engine.socket.server.emit('e', {
                type: 'data',
                log: log2
            });
        } catch (e) {
            console.error(e);
        }
        setTimeout(function (data) {
            engine.Apifo2.modify_live_call(data, function (err, result) {
                console.log(result);
                if (err) {
                    console.error(err);
                    res.status(err.status || 400).end(err.toString());
                } else res.end(result.toString());


                var now = new Date();
                var log2 = now.getHours() + ':' + now.getMinutes() + ':' + now.getSeconds() + '.' + now.getMilliseconds() + ' R Service > Phone ' + res.statusCode + ' ' + res.statusMessage + '\r\n';
                log2 += '               ' + JSON.stringify(result);
                engine.socket.server.emit('e', {
                    type: 'data',
                    log: log2
                });
            })
        }, 3000, data)
    });

    router.use('/*', function (req, res, next) {
        console.log(req.headers);
        res.sendStatus(404);
    });
    return router;
};
