var express = require('express'),
    fs = require('fs'),
    router = express.Router(),
    AWS = require('aws-sdk'),
    async = require('async'),
    log_file_path=path.join(__dirname,'../xml.log');
fs.open(log_file_path,'r',(err, fd) => {
    if (err) fs.writeFile(log_file_path, '', err => {if(err) console.log(err)});
});
var number_B = '883140340000009', number_C = '16462574500';


module.exports = function(engine){
    router.get('/xml/',(req,res) => {
        res.render('xml_index',{domain:config.domain});
    });
    router.get('/xml/log',(req,res) => {
        res.header('Content-Type','text/plain');
        var data_length=0;
        fs.readFile(log_file_path, (err, data) => {
            if(err) throw err;
            res.write(data.toString());
            data_length=data.toString().length;
            console.log( res.headersSent, res.getAllHeaders, res.headers )
            fs.watchFile(log_file_path, (curr, prev) => {
                if(curr.size != prev.size) fs.readFile(log_file_path, (err, data) => {
                    if (err) throw err;
                    res.write(data.toString().substr(data_length));
                    data_length=data.toString().length;
                });
            });
        });
        console.log( res.headersSent, res.getAllHeaders )
    });
    router.get('/xml/clearlog',(req,res) => {
        res.header('Content-Type','text/html');
        fs.writeFile(log_file_path, '', err => {if(err) console.log(err)});
        res.end('Ok <script>window.close();</script>');
    });

    router.use('*',(req,res,next) => {
        var log =                       '> '+new Date().toUTCString()+'\r\n' +
                                        '> '+req.method+'\r\n' +
                                        '> '+req.originalUrl+'\r\n';
        for(var i in req.headers)log += '> '+i+': '+req.headers[i]+'\r\n';
        console.log(req.query,req.body);
        if(req.query) log +=            '> '+JSON.stringify(req.query)+'\r\n';
        if(req.body) log +=             '> '+JSON.stringify(req.body)+'\r\n';
        log +=                          '> \r\n';
        fs.appendFile(log_file_path,log);
        next();

        var now = new Date();
        var log2 = now.getHours()+':'+now.getMinutes()+':'+now.getSeconds()+'.'+now.getMilliseconds()+' F MTT > Service '+req.method+' '+req.originalUrl+'\r\n';
        log2 += '               '+JSON.stringify(req.body);

        engine.socket.server.emit('e',{
            type:'input',
            log:log2
        });
    });

    router.get('/xml/usa.php',(req,res) => {
        res.status(500).end('PHP Die error occurred. If the horse is dead, dismount.');
    });

    router.get('/xml/ivr.php',(req,res) => {
        res.status(500).end('PHP Die error occurred. If the horse is dead, dismount.');
    });

    router.post('/xml/getInput', (req,res) => {
        var xml=`<?xml version="1.0" encoding="UTF-8" ?>
            <response>
                <getInput controller="`+config.domain+`/controlers/ivr.php" method="POST">
                    <playAudio>`+config.domain+`/audio/music_16khz_x3.wav</playAudio>
                </getInput>
            </response>`;
        res.end(xml);
        var log =                       '< '+new Date().toUTCString()+'\r\n' +
                                        '< HTTP/1.1 '+res.statusCode+' '+res.statusMessage+' \r\n';
        for(var i in res.headers) log += '< '+i+': '+res.headers[i]+'\r\n';
        log +=                          '< \r\n';
        log +=                          xml +'\r\n';
        fs.appendFile(log_file_path,log);
    });

    router.post('/xml/incoming', (req,res) => {
        /* AMAZON */
        AWS.config.update(config.amazon);
        async.waterfall([
            next => engine.db.get_number(req.body.to,next),
            (number,next) => {
                var push_id = {};
                try{
                    push_id = JSON.parse(number.push_id) || {};
                }catch(e){
                    console.error(e);
                }
                next(null,push_id);
            },
            (push_data,next) => {
                var payload = {
                    "default" : "Incoming call from "+req.body.from,
                    GCM:JSON.stringify({
                         title:"Knock Knock Callout",
                         color:"#009911",
                         sound: "default",
                         data:{
                             message : "Incoming call from "+req.body.from,
                             number : req.body.from,
                             call_sid : req.body.call_sid
                         }
                    }),
                    APNS_SANDBOX:JSON.stringify({
                        "aps" : {
                            "alert" : "Incoming call from "+req.body.from+"\uD83C\uDDF7\uD83C\uDDFA\uD83D\uDCDE\uD83D\uDD14",
                            "payload":{
                                "number" : req.body.from,
                                "call_sid" : req.body.call_sid
                            },
                            "sound" : "default"
                        }
                    })
                };

                var now = new Date();
                var log2 = now.getHours()+':'+now.getMinutes()+':'+now.getSeconds()+'.'+now.getMilliseconds()+' R Service > AWS SNS\r\n';
                log2 += '               '+JSON.stringify({
                        TargetArn: push_data.arn,
                        Message: JSON.stringify(payload),
                        MessageStructure: 'json'
                    });
                engine.socket.server.emit('e',{
                    type:'/push_sent',
                    log:log2
                });

                var sns = new AWS.SNS();
                sns.publish({
                    TargetArn: push_data.arn || push_data.arn_android,
                    Message: JSON.stringify(payload),
                    MessageStructure: 'json'
                },function(err,data) {
                    if (err) {
                        console.error("Error sending a message ", err);
                        res.status(500).end(err);
                    } else {
                        console.log("Sent message: ", data);


                        var now = new Date();
                        var log2 = now.getHours()+':'+now.getMinutes()+':'+now.getSeconds()+'.'+now.getMilliseconds()+' R AWS SNS > Service\r\n';
                        log2 += '               '+JSON.stringify(data);
                        engine.socket.server.emit('e',{
                            type:'/push_succes',
                            log:log2
                        });

                        next();
                    }
                });




            }
        ],function(err,r){
            if(err) console.error(err);
            var xml=`<?xml version="1.0" encoding="UTF-8" ?>
            <response>
                <playAudio loops="1">http://127.0.0.1:8000/audio/music_16khz_x3.wav</playAudio>
            </response>`;
            res.end(xml);

            var log =                       '< '+new Date().toUTCString()+'\r\n' +
                '< HTTP/1.1 '+res.statusCode+' '+res.statusMessage+' \r\n';
            for(var i in res.headers) log+= '< '+i+': '+res.headers[i]+'\r\n';
            log +=                          '< \r\n';
            log +=                          xml +'\r\n';
            fs.appendFile(log_file_path,log);


            var now = new Date();
            var log2 = now.getHours()+':'+now.getMinutes()+':'+now.getSeconds()+'.'+now.getMilliseconds()+' F Service > MTT '+res.statusCode+' '+res.statusMessage+'\r\n';
            log2 += '               '+xml;

            engine.socket.server.emit('e',{
                type:'/xml/incoming',
                log:log2
            });

        });
        /* END AMAZON */
    });

    router.post('/xml/goTo', (req,res) => {
        var xml = `<?xml version="1.0" encoding="UTF-8" ?>
            <response>
                <goTo method="POST">`+config.domain+`/xml/usa.php</goTo>
            </response>`;
        res.end(xml);
        var log =                       '< '+new Date().toUTCString()+'\r\n' +
            '< HTTP/1.1 '+res.statusCode+' '+res.statusMessage+' \r\n';
        for(var i in res.headers) log += '< '+i+': '+res.headers[i]+'\r\n';
        log +=                          '< \r\n';
        log +=                          xml +'\r\n';
        fs.appendFile(log_file_path,log);
    });
    router.post('/xml/wait', (req,res) => {
        var xml = `<?xml version="1.0" encoding="UTF-8" ?>
            <response>
                <makeCall timeout=10>
                    <number>`+(req.body.to || number_B)+`</number>
                </makeCall>
                <wait length="30"></wait>
                <makeCall>
                    <number>`+number_C+`</number>
                </makeCall>
            </response>`;
        res.end(xml);
        var log =                       '< '+new Date().toUTCString()+'\r\n' +
            '< HTTP/1.1 '+res.statusCode+' '+res.statusMessage+' \r\n';
        for(var i in res.headers) log += '< '+i+': '+res.headers[i]+'\r\n';
        log +=                          '< \r\n';
        log +=                          xml +'\r\n';
        fs.appendFile(log_file_path,log);
    });
    router.post('/xml/endCall', (req, res) => {
        var xml = `<?xml version="1.0" encoding="UTF-8" ?>
            <response>
                <endCall signal="busy"></endCall>
            </response>`;
        res.end(xml);
        var log =                       '< '+new Date().toUTCString()+'\r\n' +
            '< HTTP/1.1 '+res.statusCode+' '+res.statusMessage+' \r\n';
        for(var i in res.headers) log += '< '+i+': '+res.headers[i]+'\r\n';
        log +=                          '< \r\n';
        log +=                          xml +'\r\n';
        fs.appendFile(log_file_path,log);
    });

    router.post('/xml/makeCall', (req, res) => {
        var xml = `<?xml version="1.0" encoding="UTF-8" ?>
            <response>
                <makeCall from="`+req.body.from+`">
                    <number>`+ req.body.to +`</number>
                </makeCall>
                <endCall/>
            </response>`;
			
		var now = new Date();
        var log2 = now.getHours()+':'+now.getMinutes()+':'+now.getSeconds()+'.'+now.getMilliseconds()+' F Service > MTT '+res.statusCode+' '+res.statusMessage+'\r\n';

        res.end(xml);

        log2 += '               '+xml+'\r\n';
        engine.socket.server.emit('e',{
            type:'/xml/makeCall',
            log:log2
        });
        engine.wait_call(req.body.call_sid);
    });
	
    router.get('/xml/makeCall', (req, res) => {
        var xml = `<?xml version="1.0" encoding="UTF-8" ?>
            <response>
                <makeCall from="`+req.query.from+`">
                    <number>`+ req.query.to  +`</number>
                </makeCall>
                <endCall/>
            </response>`;
        res.end(xml);
        var log =                       '< '+new Date().toUTCString()+'\r\n' +
            '< HTTP/1.1 '+res.statusCode+' '+res.statusMessage+' \r\n';
        for(var i in res.headers) log+= '< '+i+': '+res.headers[i]+'\r\n';
        log +=                          '< \r\n';
        log +=                          xml +'\r\n';
        fs.appendFile(log_file_path,log);


        var now = new Date();
        var log2 = now.getHours()+':'+now.getMinutes()+':'+now.getSeconds()+'.'+now.getMilliseconds()+' F Service > MTT '+res.statusCode+' '+res.statusMessage+'\r\n';
        log2 += '               '+xml+'\r\n';
        engine.socket.server.emit('e',{
            type:'/xml/makeCall',
            log:log2
        });
        engine.wait_call(req.query.call_sid);
    });

    router.post('/xml/makeCall/sequence', (req, res) => {
        var xml = `<?xml version="1.0" encoding="UTF-8" ?>
            <response>
                <makeCall timeout=10>
                    <number>`+ (req.body.to || number_B) +`</number>
                </makeCall>
                <makeCall>
                    <number>`+number_C+`</number>
                </makeCall>
            </response>`;
        res.end(xml);
        var log =                       '< '+new Date().toUTCString()+'\r\n' +
                                        '< HTTP/1.1 '+res.statusCode+' '+res.statusMessage+' \r\n';
        for(var i in res.headers) log+= '< '+i+': '+res.headers[i]+'\r\n';
        log +=                          '< \r\n';
        log +=                          xml +'\r\n';
        fs.appendFile(log_file_path,log);
    });

    router.post('/xml/makeCall/parallel', (req, res) => {
        var xml = `<?xml version="1.0" encoding="UTF-8" ?>
            <response>
                <makeCall>
                    <number>`+ (req.body.to || number_B) +`</number>
                    <number>`+number_C+`</number>
                </makeCall>
            </response>`;
        res.end(xml);
        var log =                       '< '+new Date().toUTCString()+'\r\n' +
            '< HTTP/1.1 '+res.statusCode+' '+res.statusMessage+' \r\n';
        for(var i in res.headers) log += '< '+i+': '+res.headers[i]+'\r\n';
        log +=                          '< \r\n';
        log +=                          xml +'\r\n';
        fs.appendFile(log_file_path,log);
    });

    router.all('*',(req,res, next) => {
        res.status(404).end('404 - Not Found');
    });

    return router;
}
